<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

$api = app('Dingo\Api\Routing\Router');
$api->version('v1', function ($api) {
    /* 财务路由 */
    $api->group(['namespace'=>'Modules\Finance\Http\Controllers'],function ($api) {
        /* 资金路由 */
        $api->group(['prefix'=>'money'], function ($api){
            $api->get('index', 'MoneyController@index');
            $api->get('detail', 'MoneyController@detail');
            $api->post('income', 'MoneyController@income');
            $api->post('deductions', 'MoneyController@deductions');
            $api->get('export', 'MoneyController@export');
            $api->post('import', 'MoneyController@import');
            $api->post('add_income_style', 'MoneyController@addIncomeStyle');
            $api->get('get_income_style', 'MoneyController@getIncomeStyle');
            $api->post('delete_income_style', 'MoneyController@deleteIncomeStyle');
            $api->get('get_payment_list', 'MoneyController@getPaymentList');
            $api->get('export_payment_list', 'MoneyController@exportPaymentList');
            $api->get('get_many_back_money_user','MoneyController@getManyBackMoneyUser');
        });

        $api->group(['prefix'=>'userpay'],function ($api){
            $api->post('add_money','UserPayController@add_money');
            $api->post('user_account','UserPayController@user_account');
            $api->post('search','UserPayController@search');
            $api->post('user_pay_log','UserPayController@user_pay_log');
            $api->post('UserPayCancel','UserPayController@UserPayCancel');
        });
    });
});
