<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\VideoUploadHandler;
use App\Models\DeviceAccount;
use Illuminate\Http\Request;
use Carbon\Carbon;

class DeviceAccountController extends Controller
{
    /**获取扫码枪账号**/
    public function GetSMAccount(Request $request){
        $status=$request->input('status',-1)??-1;

        $query=DeviceAccount::where('type',0);
        if ($status>=0){
            $query->where('status',$status);
        }

        return $this->success($query->get());

    }

    /**新增用户**/
    public function AddUser(Request $request){
        $data=$request->all();

        $count=DeviceAccount::where('name',$data['name'])->count();
        if ($count){
            return $this->error(500214,'该名称已存在');
        }

        if (mb_strlen($data['password'])<8){
            return $this->error(500214,'密码不得少于八位！');
        }

        $data['created_at']=Carbon::now()->toDateTimeString();
        $data['updated_at']=Carbon::now()->toDateTimeString();
        $data['password']=sha1($data['password']);
        DeviceAccount::insert($data);
        return $this->success([]);
    }

    /**更新**/
    public function UpdateDeviceAccount(Request $request){
        $re=DeviceAccount::find($request->input('id'));
        $re->status=$request->input('status');
        $re->save();
        return $this->success([]);

    }
}
