<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\UploadFilesHandler;
use App\Models\Guide;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Http\Request;

class GuideController extends Controller
{
    //获取教程信息列表
    public function getGuideList(Request $request){
        $input=$request->all();
        $page_size=$input['page_size'];
        $page_index=$input['page_index'];
        $num = ($page_index - 1) * $page_size;
        $search_name=$input['search_name'];
        $where=[];
        $where['type']=$input['type'];
        $count=Guide::where('title', 'like', '%' . $search_name . '%')
            ->where($where)
            ->count();
        if($count==0){
            $this->error('400001','没有数据');
        }
        $list=Guide::where('title', 'like', '%' . $search_name . '%')
            ->where($where)
            ->orderBy('id', 'desc')
            ->skip($num)->take($page_size)
            ->get();
        if(empty($list)){
            return $this->error('400002','没有获取到数据');
        }
        return $this->success_list($list,'success',$count);
    }
    //上传图片
    public function uploadGuideFiles(Request $request){
        $input=$request->all();
        $file= $request->file('file');
        switch ($input['type']){
            case 1:
                $path_url='guide/video';
                $t='video';
                break;
            case 2:
                $path_url='guide/picture';
                $t='image';
                break;
            default:
                $path_url='guide/default';
                $t='image';
        }
        $upload= new UploadFilesHandler();
        $result= $upload->save($file, $path_url, null, $t);
        if($result){
            return $this->success($result['path']);
        }
        return $this->error();

//        $input=$request->all();
//        //轮播图   //授权书   //商品相册    //社区相册
//        switch ($input['type']){
//            case 1:   // 轮播图
//                $path_url='guide/video';
//                break;
//            case 2:   // 授权书
//                $path_url='guide/picture';
//                break;
//        }
//        $path = $request->file('file')->store($path_url);
//        $url = Storage::url($path);
//        if($url){
//            return $this->success($url);
//        }
//        return $this->error();
    }
//添加教程信息
    public function uploadGuide(Request $request){
        $input=$request->all();
        $data['title']=$input['title'];
        $data['url']=$input['url'];
        $data['type']=$input['type'];
        $data['status']=1;
        $data['aid']=Auth::user()->id;
        $data['contents']=$input['contents'];
        $row=Guide::create($data);
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')添教程成功，教程id:'.$row->id);
            return $this->success([]);
        }
        return $this->error();
    }

    //修改教程信息
    public function updateGuide(Request $request){
        $input=$request->all();
        $data['title']=$input['title'];
        $data['url']=$input['url'];
        $data['type']=$input['type'];
        $data['aid']=Auth::user()->id;
        $data['contents']=$input['contents'];
        $row=Guide::where('id',$input['id'])->update($data);
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改教程成功,教程id:'.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }

    /*  教程禁用  */
    public function disableGuide(Request $request){
        $input=$request->all();
        $guide=Guide::find($input['id']);
        $guide->status=($guide->status==0)?1:0;
        $row=$guide->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')禁用教程成功,教程id:'.$input['id']);
            return $this->success([]);
        } else {
            return $this->error();
        }
    }

    //删除教程信息
    public function destoryGuide(Request $request){
        $input=$request->all();
        $guide=Guide::find($input['id']);
        $row=$guide->delete();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')删除教程成功,教程id:'.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }
}
