<?php

namespace Modules\Manager\Http\Controllers;

use App\Models\Info;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Http\Request;
use Intervention\Image\Image;
use Zxing\QrReader;

class InfoController extends Controller
{
    //获取公告信息列表
    public function getInfoList(Request $request){

//        $arr=["title"=>"买家已下单赶紧去发货吧",
//            "money"=> "14956",
//            "name"=> "张夏利",
//            "phone"=> "15266666666",
//            "address"=> "河南省郑州市经开区大十五大街炒河街道华夏校区竹林苑",
//            "time"=> "2021-12-20 08:59:00",
//            "url"=> "/index/index"
//        ];
//        Info::whereIn('id',[32,43])->update([
//            'contents'=>json_encode($arr)
//        ]);
//
//        exit;


//        return $this->success(json_encode($arr));

        $input=$request->all();
        $page_size=$input['page_size'];
        $page_index=$input['page_index'];
        $num = ($page_index - 1) * $page_size;
        $search_name=$input['search_name'];
        $where=[];
        $count=Info::where($where)->where('type',1)
            ->count();
        if($count==0){
            $this->error('400001','没有数据');
        }
        $list=Info::where($where)->where('type',1)
            ->orderBy('is_top','desc')
            ->orderBy('top_at','desc')
            ->orderBy('created_at', 'desc')
            ->skip($num)->take($page_size)
            ->get();
        if(empty($list)){

            return $this->error('400002','没有获取到数据');
        }
        return $this->success_list($list,'success',$count);
    }
//添加公告信息
    public function uploadInfo(Request $request){
        $input=$request->all();
//        $data['title']=$input['title'];
        $data['adminid']=Auth::user()->id;
        $data['author']=$input['author'];
        $data['status']=1;
        $data['is_top']=0;// 1表示置顶，0表示不置顶
        $data['contents']=$input['contents'];
        $row=Info::create($data);
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')添加公告成功,公告id:'.$row->id);
            return $this->success([]);
        }
        return $this->error();
    }
    //截取简介
    function make_excerpt($value, $length = 200)
    {
        $excerpt = trim(preg_replace('/\r\n|\r|\n+/', ' ', strip_tags($value)));
        return str_limit($excerpt, $length);
    }
    //修改公告信息
    public function updateInfo(Request $request){
        $input=$request->all();
//        $data['title']=$input['title'];
        $data['adminid']=Auth::user()->id;
        $data['author']=$input['author'];
        $data['contents']=$input['contents'];
        $row=Info::where('id',$input['id'])->update($data);
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改公告成功,公告id:'.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }
    /*  公告置顶  */
    public function setInfoTop(Request $request){
        $input=$request->all();
        $info=Info::find($input['id']);
        $info->is_top=($info->is_top=='0')?'1':'0';
        $info->top_at=date("Y-m-d H:i:s");
        $row=$info->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')置顶公告成功,公告id:'.$input['id']);
            return $this->success([]);
        } else {
            return $this->error();
        }
    }

    /*  公告禁用  */
    public function disableInfo(Request $request){
        $input=$request->all();
        $info=Info::find($input['id']);
        $info->disabled=($info->disabled==0)?1:0;
        $row=$info->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')禁用公告成功,公告id:'.$input['id']);
            return $this->success([]);
        } else {
            return $this->error();
        }
    }

    //删除社区信息
    public function destoryInfo(Request $request){
        $input=$request->all();
        $info=Info::find($input['id']);
        $row=$info->delete();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')删除公告成功,公告id:'.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }


    public function setType4Storage(){
//        $goods=UserStorage::where('user_id','39516')->select('id','sex','type','size')->get();
        //处理type==4库存
//       $user_ids=UserStorage::where('type',4)->groupBy('user_id')->pluck('user_id');
//        DB::transaction(function()use($user_ids,$goods){
//            foreach($user_ids as $key=>$val){
//                foreach($goods as $k=>$v){
//                    $res=UserStorage::where('user_id',$val)->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->first();
//                    if(empty($res)){
//                        UserStorage::create([
//                            'user_id'=>$val,
//                            'sex'=>$v->sex,
//                            'size'=>$v->size,
//                            'type'=>$v->type,
//                            'num'=>0
//                        ]);
//                    }
//                }
//            }
//            UserStorage::where('type',4)->delete();
//        },5);

        //处理num < 32
//        $user_ids = UserStorage::select('user_id',DB::raw('count(*) as count'))->groupBy('user_id')->having('count','<','32')->pluck('user_id');
//        DB::transaction(function()use($user_ids,$goods){
//            foreach($user_ids as $key=>$val){
//                foreach($goods as $k=>$v){
//                    $res=UserStorage::where('user_id',$val)->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->first();
//                    if(empty($res)){
//                        UserStorage::create([
//                            'user_id'=>$val,
//                            'sex'=>$v->sex,
//                            'size'=>$v->size,
//                            'type'=>$v->type,
//                            'num'=>0
//                        ]);
//                    }
//                }
//            }
//        },5);
        //处理num > 32
//        $user_ids = UserStorage::select('user_id',DB::raw('count(*) as count'))->groupBy('user_id')->having('count','>','32')->pluck('user_id');
//        DB::transaction(function()use($user_ids,$goods){
//            foreach($user_ids as $key=>$val){
//                foreach($goods as $k=>$v){
//                    $res=UserStorage::where('user_id',$val)->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->count();
//                    if($res<1){
//                        UserStorage::create([
//                            'user_id'=>$val,
//                            'sex'=>$v->sex,
//                            'size'=>$v->size,
//                            'type'=>$v->type,
//                            'num'=>0
//                        ]);
//                    }elseif($res>1){
//                        $min_id=UserStorage::where('user_id',$val)->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->min('id');
//                        return $min_id;
//                        UserStorage::where('user_id',$val)->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->where('id','!=',$min_id)->delete();
//                    }
//                }
//            }
//            //商品规格不在正常范围
//            foreach($user_ids as $key=>$val){
//                $gs=UserStorage::where('user_id',$val)->get();
//                foreach($gs as $k=>$v){
//                    $c=UserStorage::where('user_id','39516')->where('sex',$v->sex)->where('size',$v->size)->where('type',$v->type)->count();
//                    if($c==0){
//                        UserStorage::where('id',$v->id)->delete();
//                    }
//                }
//            }
//        },5);

    }

    public function Scan(Request $request){
        $qrcode = new QrReader($request->file('image'));
//        $qrcode = new QrReader(public_path().'/5vnth2qdre82xszara98tm03p_0.jpg');
        $text = $qrcode->text();
        dd($text);
    }
}
