<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\DateConversion;
use App\Models\Message;
use Carbon\Carbon;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;
use Illuminate\Http\Request;

class MessageController extends Controller
{
    //获取消息信息列表
    public function getMessageList(Request $request){
        $input=$request->all();
        $page_size=$input['page_size'];
        $page_index=$input['page_index'];
        $num = ($page_index - 1) * $page_size;
        $search_name=$input['search_name'];
        $where=[];
        $where['type']=$input['type'];
        $count=Message::where('title', 'like', '%' . $search_name . '%')
            ->where($where)
            ->count();
        if($count==0){
            $this->error('400001','没有数据');
        }
        $list=Message::where('title', 'like', '%' . $search_name . '%')
            ->where($where)
            ->orderBy('id', 'desc')
            ->skip($num)->take($page_size)
            ->get();
            // foreach($list as $key=>$val){
            //     $list[$key]->datas=json_decode($val->data);
            // }
        if(empty($list)){
            return $this->error('400002','没有获取到数据');
        }
        return $this->success_list($list,'success',$count);
    }


    //修改消息信息
    public function updateMessage(Request $request){
        $input=$request->all();
        $data['title']=$input['title'];
        $data['url']=$input['url'];
        $data['type']=$input['type'];
        $data['data']=$input['data'];
        $row=Message::where('id',$input['id'])->update($data);
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改消息成功,消息id:'.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }

    public function test(Request $request){
        $date=$request->input('date',Carbon::now()->toDateTimeString());
        $DateConversion = new DateConversion();
        $year=Carbon::parse($date)->year;
        $month=Carbon::parse($date)->month;
        $day=Carbon::parse($date)->day;
        $date_info = $DateConversion->convertSolarToLunar($year, $month, $day);

        $calendar=$month.'-'.$day;
        $lunar_calendar=$date_info[1].$date_info[2];
        $dt = Carbon::parse($date)->dayOfWeek;
        $week=['0'=>'日','1'=>'一','2'=>'二','3'=>'三','4'=>'四','5'=>'五','6'=>'六'];
        $info='今天是'.$calendar.',农历'.$lunar_calendar.',星期'.$week[$dt].'('.$dt.')';
        Log::info($info);
        return $this->success($info);
    }
}
