<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\UploadFilesHandler;
use App\Models\WechatNotice;
use Illuminate\Http\Request;
use Carbon\Carbon;

class NoticeController extends Controller
{
    public function GetNoticeList(Request $request){
        $page_index=$request->input('page_index');
        $page_size=$request->input('page_size');
        $search_name=$request->input('search_name');
        $re=WechatNotice::query();
        if ($search_name){
            $re->where('title','like',"%$search_name%");
        }
        $count=$re->count();

        $re=$re->orderByDesc('is_top')->orderByDesc('created_at')
            ->select('title','time','id','is_top','description','cover')
            ->take($page_size)
            ->skip(($page_index-1)*$page_size)
            ->get();
        return $this->success_list($re,'',$count);
    }

    public function WeChatNotice(Request $request){
        $id=$request->input('id');
        $text=WechatNotice::find($id);
        return $this->success($text);
    }

    public function UpdateWeChatNotice(Request $request){
        if ($request->has('id')){
            $id=$request->input('id');
            $notice=WechatNotice::find($id);
        }else{
            $notice=new WechatNotice();
        }

        $notice->title=$request->input('title','');
        $notice->time=$request->input('time',Carbon::now()->toDateTimeString());
        $notice->notice=$request->input('notice','');
        $notice->is_top=$request->input('is_top',0);
        $notice->cover=$request->input('cover','');
        $notice->description=$request->input('description','');
        $notice->save();
        return $this->success([]);
    }

    public function DelNotice(Request $request){
        WechatNotice::where('id',$request->input('id'))->delete();
        return $this->success([]);
    }

    //上传图片
    public function uploadGoodsImage(Request $request)
    {
        $file = $request->file('file');
        $path_url = 'notice/notice';
        $upload = new UploadFilesHandler();
        $result = $upload->save($file, $path_url, null, 'image');
        if ($result) {
            return $this->success($result['path']);
        }
        return $this->error();
    }
}
