<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\UploadFilesHandler;
use App\Models\OnlineReport;
use Illuminate\Http\Request;

class ReportController extends Controller
{
    /*
    * 在线报告
    * ***/
    public function AddUpdateReport(Request $request){
        $id=$request->input('id',null);
        $name=$request->input('name','');
        $data=$request->input('data');
        $cover=$request->input('cover');
        $type=$request->input('type');

        if (empty($id)){
            $report=new OnlineReport();
        }else{
            $report=OnlineReport::find($id);
        }
        $report->name=$name;
        $report->data=json_encode($data);
        $report->type=$type;
        $report->cover=$cover;
        $report->save();
        return $this->success([]);
    }

    /*
     * 获取报告
     * **/
    public function GetReport(Request $request){
        $type=$request->input('type',1);

        $re=OnlineReport::where('type',$type)->first();
        return $this->success($re);
    }

    /*
     * 获取封面
     * **/
    public function GetCover(){
        $img=OnlineReport::pluck('cover','id');
        return $this->success($img);
    }

    /*
     * 获取报告列表
     * **/
    public function GetReportList(Request $request){
        $re=OnlineReport::all();
        return $this->success($re);
    }

    //上传图片
    public function uploadImage(Request $request)
    {
        $file = $request->file('file');
        $path_url = 'report/report';
        $upload = new UploadFilesHandler();
        $result = $upload->save($file, $path_url, null, 'image');
        if ($result) {
            return $this->success($result['path']);
        }
        return $this->error();
    }
}
