<?php

namespace Modules\Manager\Http\Controllers;

use App\Handlers\UploadFilesHandler;
use App\Handlers\VideoUploadHandler;
use App\Models\System;
use App\Models\Goodtest;
use App\Models\VideoInfo;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Auth;
use \Exception;

class SettingController extends Controller
{
    //获取设置信息
    public function getSetting(){
        $setting=System::all();
        if($setting){
            return $this->success($setting);
        }
        return $this->error();
    }
    //更新奖励支出
    public function updateRewardPay(Request $request){
        $input=$request->all();
        switch($input['type']){
            case '1':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
               $key='reward_super_super';
               $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
               break;
            case '2':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
                $key='reward_super_top';
                $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
                break;
            case '3':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
                $key='reward_super_crown';
                $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
                break;
            case '4':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
                $key='reward_top_top';
                $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
                break;
            case '5':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
                $key='reward_top_crown';
                $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
                break;
            case '6':
                $input['jz']=$input['jz']?$input['jz']:0;
                $input['jy']=$input['jy']?$input['jy']:0;
                $input['lr']=$input['lr']?$input['lr']:0;
                $key='reward_crown_crown';
                $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
                break;
            case '7':
                $input['jz1']=$input['jz1']?$input['jz1']:0;
                $input['jz2']=$input['jz2']?$input['jz2']:0;
                $input['jy1']=$input['jy1']?$input['jy1']:0;
                $input['jy2']=$input['jy2']?$input['jy2']:0;
                $input['lr1']=$input['lr1']?$input['lr1']:0;
                $input['lr2']=$input['lr2']?$input['lr2']:0;
                $key='reward_crown_crown_crown';
                $value=$input['jz1'].'*'.$input['jz2'].'/'.$input['jy1'].'*'.$input['jy2'].'/'.$input['lr1'].'*'.$input['lr2'];
                break;
            case '8':
                $input['jz1']=$input['jz1']?$input['jz1']:0;
                $input['jz2']=$input['jz2']?$input['jz2']:0;
                $input['jy1']=$input['jy1']?$input['jy1']:0;
                $input['jy2']=$input['jy2']?$input['jy2']:0;
                $input['lr1']=$input['lr1']?$input['lr1']:0;
                $input['lr2']=$input['lr2']?$input['lr2']:0;
                $key='reward_crown_top_crown';
                $value=$input['jz1'].'*'.$input['jz2'].'/'.$input['jy1'].'*'.$input['jy2'].'/'.$input['lr1'].'*'.$input['lr2'];
                break;
        }
        $setting=System::where('keys',$key)->first();
        $setting->values=$value;
        $row=$setting->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改奖励支出成功,奖励类型:'.$input['type']);
            return $this->success([]);
        }
        return $this->error();
    }
//修改店铺奖励
    public function updateStoreReward(Request $request){
        $input=$request->all();
        if($input['level']==1 && $input['type']=='goods'){
            $key='store_reward_goods_job';
            $value=$input['val']?$input['val']:0;
        }elseif($input['level']==2 && $input['type']=='goods'){
            $key='store_reward_goods_enjoy';
            $value=$input['val']?$input['val']:0;
        }elseif($input['level']==2 && $input['type']=='money'){
            $key='store_reward_money_enjoy';
            $input['jz']=$input['jz']?$input['jz']:0;
            $input['jy']=$input['jy']?$input['jy']:0;
            $input['lr']=$input['lr']?$input['lr']:0;
            $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
        }elseif($input['level']==3 && $input['type']=='money'){
            $key='store_reward_money_experience';
            $input['jz']=$input['jz']?$input['jz']:0;
            $input['jy']=$input['jy']?$input['jy']:0;
            $input['lr']=$input['lr']?$input['lr']:0;
            $value=$input['jz'].'/'.$input['jy'].'/'.$input['lr'];
        }
        $setting=System::where('keys',$key)->first();
        $setting->values=$value;
        $row=$setting->save();
         if($row){
             Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改店铺奖励成功,店铺等级:'.$input['level'].'奖励类型:'.$input['type']);
             return $this->success([]);
         }
        return $this->error();
    }
    //销售业绩区间奖励
    public function salesReward(Request $request){
        $input=$request->all();
        $value='';
        foreach($input['rate'] as $key=>$val){
            $str=$val['start'].'*'.$val['end'].'*'.$val['price'];
            if(empty($value)){
                $value=$str;
            }else{
                $value=$value.'/'.$str;
            }
        }
        $key='sales_area_reward';
        $setting=System::where('keys',$key)->first();
        $setting->values=$value;
        $row=$setting->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改业绩奖励成功');
            return $this->success([]);
        }
        return $this->error();
    }

    //商品设置
    public function updateSystemSet(Request $request){
        $keys=$request->post('keys');
        $setting=System::where('keys',$keys)->first();
        $setting->values=($setting->values=='1')?'0':1;
        $row=$setting->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改设置成功，key='.$keys);
            return $this->success([]);
        }
        return $this->error();
    }

    //代理升级设置
    public function agentsUpLevel(Request $request){
        $input=$request->all();
        $input['tjMoney']=$input['tjMoney']?$input['tjMoney']:0;
        $input['djMoney']=$input['djMoney']?$input['djMoney']:0;
        try{
            $activityTime=System::where('keys','activity_time')->first();
            $activityTime->values=implode('/',$input['time']);
            $activityTime->save();

            $activity=System::where('keys','activity_start')->first();
            $activity->values=$input['status'];
            $activity->save();

            $upgrade_standard=System::where('keys','upgrade_standard')->first();
            $upgrade_standard->values=$input['tjMoney'].'/'.$input['djMoney'];
            $upgrade_standard->save();

//            $downgrade_standard=System::where('keys','downgrade_standard')->first();
//            $downgrade_standard->values=$input['hgdownMoney'].'/'.$input['djdownMoney'];
//            $downgrade_standard->save();
        }catch(Exception $e) {
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改代理升级设置成功');
            return $this->error();
        }
        return $this->success([]);

    }

    //添加设置
    public function uploadSetting(Request $request){
        $input=$request->all();
        $setting=new System;
        $setting->title=$input['title'];
        $setting->keys=$input['keys'];
        $setting->values=$input['values'];
//        $setting->content=$input['content'];
        $setting->desc=$input['desc'];
        $row=$setting->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')添加设置成功，id='.$row->id);
            return $this->success([]);
        }
        return $this->error();

    }
    //更新设置
    public function updateSetting(Request $request){
        $input=$request->all();
        $setting=System::find($input['id']);
        $setting->keys=$input['keys'];
        $setting->title=$input['title'];
        $setting->values=$input['values'];
        $setting->desc=$input['desc'];
        $row=$setting->save();
        if($row){
            Log::info('管理员:'.Auth::user()->name.'(id='.Auth::user()->id.')修改设置成功，id='.$input['id']);
            return $this->success([]);
        }
        return $this->error();
    }

    /***/
    public function SetVRLink(Request $request){
        System::where('keys','vr_glory_link')->update(['values'=>$request->vr_link]);
        return $this->success([]);
    }
    public function GetVRLink(){
        $link=System::where('keys','vr_glory_link')->value('values');
        return $this->success(['vr_link'=>$link]);
    }

    public function GetUpgradeInfo(){
        $re=System::whereIn('keys',['upgrade_status','upgrade_start_time','upgrade_end_time'])->pluck('values','keys');
        $data=[
            'status'=>$re['upgrade_status'],
            'start_time'=>$re['upgrade_start_time'],
            'end_time'=>$re['upgrade_end_time'],
        ];
        return $this->success($data);
    }

    public function UpdateUpgradeInfo(Request $request){
        $status=$request->input('status')??0;
        $start_time=$request->input('start_time')??null;
        $end_time=$request->input('end_time')??null;
        System::where('keys','upgrade_status')->update(['values'=>$status]);
        System::where('keys','upgrade_start_time')->update(['values'=>$start_time]);
        System::where('keys','upgrade_end_time')->update(['values'=>$end_time]);
        return $this->success([]);
    }

    /*
     * 设置操作视频
     * **/
//    public function UploadVideo(Request $request,VideoUploadHandler $uploadHandler){
//        if (!$request->file('video')){
//            return $this->error();
//        }
//
//        $url=$uploadHandler->save($request->video,'video','1');
//
//        return $this->success($url);
//    }
    public function UploadVideo(Request $request){
        $file= $request->file('video');
        if($file){
            $path_url='setting/video';
            $upload= new UploadFilesHandler();
            $result= $upload->save($file, $path_url, '1', 'video');
            if($result){
                return $this->success($result);
            }
        }
        return $this->error();
    }

    /*
     * 获取操作视频
     * **/
    public function GetVideo(){
        return $this->success(VideoInfo::where('status',0)->where('type',0)->orderBy('sort')->orderBy('id')->get());
    }

    public function AddVideo(Request $request){
        $video=new VideoInfo();
        $video->video_url=$request->input('url');
        $video->type=0;
        $video->sort=$request->sort;
        $video->title=$request->title;
        $video->status=$request->status;
        $video->save();
        return $this->success([]);
    }

    public function UpdateVideo(Request $request){
        $video=VideoInfo::find($request->id);
        $video->video_url=$request->input('url');
        $video->type=0;
        $video->sort=$request->sort;
        $video->title=$request->title;
        $video->status=$request->status;
        $video->save();
        return $this->success([]);
    }

    public function getGoodsMain(Request $request){
        $goods=Goodtest::query()->where('is_deleted',0)->groupBy('main_attr')->pluck('main_attr');
        return $this->success($goods);
    }

    //设置店铺补贴
    public function updateStoreSubsidies(Request $request){
        $input=$request->all();
        if($input['level']==2){
            $key='store_reward_money_enjoy';
        }else{
            $key='store_reward_money_experience';
        }
        $value=json_encode($input['value'],JSON_UNESCAPED_UNICODE);
        $row=System::where('keys',$key)->update([
            'values'=>$value
        ]);
        if($row){
            return $this->success([]);
        }
        return $this->error();
    }
    //获取店铺补助标准
    public function getStoreSubsidies(Request $request){
        $info=System::whereIn('keys',['store_reward_money_enjoy','store_reward_money_experience'])->get();
        return $this->success($info);
    }
    //设置补助方式
    public function setSubsidiesType(Request $request){
        $type=$request->input('type');
        $res=System::where('keys','subsidies_type')->update([
            'values'=>json_encode($type,JSON_UNESCAPED_UNICODE)
        ]);
        if($res){
            return $this->success([]);
        }
       return $this->error();
    }
    //获取补助方式
    public function getSubsidiesType(Request $request){
        $info=System::where('keys','subsidies_type')->first();
        return $this->success($info);
    }


}


