<?php

namespace Modules\Manager\Http\Controllers;

use Modules\Manager\Jobs\Trace\DownloadFileJob;
use Modules\Manager\Jobs\Trace\SerialStatus;
use App\Models\Ordertest;
use App\Models\SendGoodLog;
use Carbon\Carbon;
use Maatwebsite\Excel\Facades\Excel;
use Rap2hpoutre\FastExcel\FastExcel;
//use App\Exports\TraceExport;
//use App\Exports\TraceTestExport;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;
use App\Jobs\Trace as CrTr;
use App\Jobs\CrossTrace;
use Modules\Manager\Jobs\Trace\CrossTraceTest;
use Illuminate\Http\Request;
use App\Models\User;
use App\Models\Trace;
use App\Models\TraceTest;
use App\Models\Serial;
use App\Models\Express;
use Ramsey\Uuid\Uuid;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class TraceController extends Controller
{
    public function index(Request $request){
        $input=$request->all();
        $page_index=$input['page_index'];
        $page_size=$input['page_size'];
        $num=$page_size*($page_index-1);
        $model=$input['model'];
        $where=[];
        if(!empty($model)){
            $where['model']=$model;
        }
        $count=Serial::outsideLog()->where($where)->count();
        $list=Serial::outsideLog()->where($where)->skip($num)->take($page_size)
            ->orderByDesc('created_at')->get();

        return $this->success_list($list,'成功',$count);
    }

    public function getTraceInfo(Request $request){
        $input=$request->all();
        $page_index=$input['page_index'];
        $page_size=$input['page_size'];
        $num=$page_size*($page_index-1);
        $model=$input['model'];
        $serial=$input['sort'];

        $count=Trace::where('pid','0')->where('serial',$serial)->where('model',$model)->count();
        $list=Trace::where('pid','0')
            ->where('serial',$serial)->where('model',$model)
            ->with(['user','get_goods','get_express'=>function($query){
                $query->orderBy('created_at','desc');
            }])
            ->skip($num)->take($page_size)->orderBy('id')->get();

        return $this->success_list($list,'成功',$count);
    }

    public function getModelInfo(){
        return $this->success(Trace::$model);
    }

    public function getChildInfo(Request $request){
        $input=$request->all();
        $pid=$input['pid'];
        $list=Trace::where('pid',$pid)->with(['user','get_goods','get_express'=>function($query){
            $query->orderBy('created_at','desc');
        }])->orderBy('sort')->get();

        return $this->success($list);
    }

    public function getCodeInfo(Request $request){
        $input=$request->all();
        $page_index=$input['page_index'];
        $page_size=$input['page_size'];
        $num=$page_size*($page_index-1);
        $code=mb_substr($input['code'],35);
        $phone=$input['phone'];
        $where=[];

        if($phone){
            $user_id=User::where('mobile',$phone)->value('id');
            if(empty($user_id)){
                $user_id='isNull';//任何非数字字符串
            }
            $where['user_id']=$user_id;

            if($code){
                $where['code']=$code;
            }else{
                $where['is_lowest']=1;
            }
        }else{
            $where['code']=$code;
        }

        $count=Trace::where($where)->with(['user','get_goods','get_express'])->count();
        $trace=Trace::where($where)->with(['user','get_goods','get_express'=>function($query){
            $query->orderBy('created_at','desc');
        }])->orderBy('sort')
            ->skip($num)->take($page_size)
            ->get();

        return $this->success_list($trace,'',$count);
    }

    public function setTrue(Request $request){
        $input=$request->all();
        $id=$input['id'];
        $trace=Trace::where('id',$id)->first();
        if($trace->is_sell==1){
            return $this->error('450001','该码及子码不能批量变更真假');
        }
        if($trace->level==1){
            $tip=substr($trace->sort,0,32);
            $user_ids=Trace::where('sort','like',$tip.'%')->pluck('user_id')->toArray();
            $uuid_count=count(array_unique($user_ids));
            if($uuid_count<1 || $uuid_count>1){
                return $this->error('450001','子码绑定代理不一致');
            }
        }
        if($trace->level==2){
            $tip=substr($trace->sort,0,34);
            $user_ids=Trace::where('sort','like',$tip.'%')->pluck('user_id')->toArray();
            $uuid_count=count(array_unique($user_ids));
            if($uuid_count<1 || $uuid_count>1){
                return $this->error('450001','子码绑定代理不一致');
            }
        }
        if($trace->is_lowest==1){
            $is_true=$trace->is_true?0:1;
        }else{
            $is_true=$input['is_true'];
        }
        DB::beginTransaction();
        try{
            if($trace->is_lowest==1){
                Trace::where('id',$id)->where(function($query){
                    $query->where('is_sell',0)
                        ->orWhereNull('is_sell');
                })->update(['is_true'=>$is_true]);
            }else{
                if($trace->level==1 ){
                    Trace::where('pid',$trace->sort)->where(function($query){
                        $query->where('is_sell',0)
                            ->orWhereNull('is_sell');
                    })->update(['is_true'=>$is_true]);
                    $sorts=Trace::where('pid',$trace->sort)->pluck('sort');
                    if(count($sorts)>0){
                        Trace::whereIn('pid',$sorts)->where(function($query){
                            $query->where('is_sell',0)
                                ->orWhereNull('is_sell');
                        })->update(['is_true'=>$is_true]);
                    }
                }

                if($trace->level==2){
                    Trace::where('pid',$trace->sort)->where(function($query){
                        $query->where('is_sell',0)
                            ->orWhereNull('is_sell');
                    })->update(['is_true'=>$is_true]);
                }
            }
            DB::commit();
            return $this->success([]);
        }catch (\Exception $e){
            DB::rollBack();
            return $this->error();
        }
    }

    public function setManyTrue(Request $request){
        $input=$request->all();
        $ids=$input['ids'];
        $is_true=$input['is_true'];
//        return $this->success(Trace::whereIn('id',$ids)->get());
        $rows=Trace::whereIn('id',$ids)
            ->where(function($query){
                $query->where('is_sell',0)
                    ->orWhereNull('is_sell');
            })->update(['is_true'=>$is_true]);
        if($rows){
            return $this->success([]);
        }else{
            return $this->error();
        }
    }

    public function setAllTrue(Request $request){
        $input=$request->all();
        $phone=$input['phone'];
        $is_true=$input['is_true'];
        $user_id=User::where('mobile',$phone)->value('id');
        if(empty($user_id)){
            return $this->error('450001','手机号有误');
        }
        $rows=Trace::where('user_id',$user_id)->where(function($query){
                $query->where('is_sell',0)
                    ->orWhereNull('is_sell');
            })->update(['is_true'=>$is_true]);
        if($rows){
            return $this->success([]);
        }else{
            return $this->error();
        }
    }

//    public function add(Request $request)
//    {
//        $input=$request->all();
//        $pid=$input['pid'];
//        if($pid==0){
//            $level=1;
//        }else{
//            $ll=Trace::where('id',$pid)->value('level');
//            $level=$ll+1;
//        }
//        $code=Trace::code();
//        Trace::create([
//            'level'=>$level,
//            'pid'=>$pid,
//            'track_status'=>0,
//            'is_true'=>0,
//            'com_binding'=>1,
//            'user_id'=>null,
//            'security_code'=>$code['sec_code'],
//            'code'=>$code['code'],
//            'child_num'=>0,
//            'select_num'=>0,
//            'is_lowest'=>1,
//        ]);
//        if($pid>0){
//            $count=Trace::where('pid',$pid)->count();
//            Trace::where('id',$pid)->update(['child_num'=>$count,'is_lowest'=>0]);
//        }
//        return $this->success([]);
//    }

    public function getSerial(Request $request){
        $input=$request->all();
        $model=$input['model'];
        $serial=Trace::where('model',$model)->groupBy('serial')->orderByDesc('serial')->pluck('is_export','serial');
        return $this->success($serial);
    }

    public function many_add(Request $request){
        ini_set('memory_limit', '10240000M');
        $input=$request->all();
        $total=$input['total'];
        $model=$input['model'];
        $grade=Trace::$model[$model]['grade'];
        $num=Trace::$model[$model]['num'];
        if($total>3000){
            return $this->error('一次最多生成3000组');
        }
        if($grade>3){
            $grade=3;
        }
        $serial=Serial::where('model',$model)->max('sort');
        if(empty($serial)){
            $serial=1;
        }else{
            $serial+=1;
        }
        Serial::create([
            'sort'=>$serial,
            'num'=>$total,
            'model'=>$model,
            'status'=>0
        ]);
        if($grade>=1){
            $mes['grade']=$grade;
            $mes['num']=$num;
            $mes['total']=100;
            $mes['model']=$model;
            $mes['serial'] = $serial;
            $t=floor($total/100);
            $n=$total%100;
            Log::info($n.'/'.$t);
            CrossTrace::dispatch(['grade'=>$grade,'num'=>$num,'total'=>$n,'model'=>$model,'serial'=>$serial]);
            for($a=0;$a<$t;$a++){
                CrossTrace::dispatch($mes);
            }
            SerialStatus::dispatch(['model'=>$model,'sort'=>$serial]);
        }
        return $this->success([]);
    }

    public function many_add1(Request $request)
    {
        $input=$request->all();
        $total=$input['total'];
        $model=$input['model'];
        $grade=Trace::$model[$model]['grade'];
        $num=Trace::$model[$model]['num'];
        if($total>3000){
            return $this->error('一次最多生成3000组');
        }
        if($grade>3){
            $grade=3;
        }
        if($grade>=1){
            $mes['grade']=$grade;
            $mes['num']=$num;
            for($i=0;$i<$total;$i++){
                CrTr::dispatch($mes);
            }
        }
        return $this->success([]);
    }

    public function destroy(Request $request){
        $input=$request->all();
        $trace=Trace::where('id',$input['id'])->first();
        if(empty($trace)){
            return $this->error('450001','数据不存在，请刷新后再操作');
        }
        DB::beginTransaction();
        try{
            $this->destroyChild($input['id']);
            $pid=$trace->pid;
            if($pid=='0'){
                Serial::where('model',$trace->model)->where('sort',$trace->serial)->decrement('num');
            }else{
                $count=Trace::where('pid',$pid)->count();
                Trace::where('sort',$pid)->update(['child_num'=>$count]);
            }
            DB::commit();
            return $this->success([]);
        }catch(\Exception $e){
            DB::rollback();
            return $this->error();
        }
    }

    public function destroyChild($id){
        $trace=Trace::where('id',$id)->first();
        $trs=Trace::where('pid',$trace->sort)->get();
        if(count($trs)>0){
            foreach($trs as $key=>$val){
                $this->destroyChild($val->id);
            }
        }
        Trace::where('id',$id)->delete();
    }

    public function destroySerial(Request $request){
        $input=$request->all();
        $id=$input['id'];
        $serial=Serial::where('id',$id)->first();
        DB::beginTransaction();
        try{
            Trace::where('model',$serial->model)->where('serial',$serial->sort)->delete();
            Serial::where('id',$id)->delete();
            DB::commit();
            return $this->success([]);
        }catch(\Exception $e){
            DB::rollBack();
            return $this->error();
        }

    }

    public function getExpressInfo(Request $request){
        $input=$request->all();
        $id=$input['id'];
        $is_lowest=Trace::where('id',$id)->value('is_lowest');
        if($is_lowest==1){
            $express=Express::where('select_id',$id)->first();
            return $this->success($express);
        }else{
            return $this->error('450001','只有最低级才能查看发货信息');
        }

    }
    public function exportSimple(Request  $request){
        ini_set('memory_limit', -1);
//        $id=$request->input('id');
//        $serial=Serial::where('id',$id)->first();
//        $status=Serial::where('model',$serial->model)->where('sort',$serial->sort)->value('status');
//        if($status==0){
//            return $this->error('450001','正在生成数据，请稍后再次操作');
//        }

        $list=TraceTest::query()
//            ->where('serial',$serial->id)
            ->whereIn('serial',['16','17','18','19','27'])
            ->where('is_lowest','1')
            ->select('id','code','security_code','model')
            ->orderBY('id','desc')->limit(400000)->get()->toArray();
        $rows=[
            "max_code"=>'大码',
            "sec_code"=>'中码',
            "min_code"=>'小码',
            "security_code"=>'防伪码',
            "model"=>'类型'
        ];
return $this->success($list);
//        return Excel::download(new TraceTestExport($rows,$list), '防伪码test.csv');
    }

    function usersGenerator() {
        $data=TraceTest::limit(500000)->cursor();
        foreach ($data as $user) {
            yield $user;
        }
    }

    function usersGeneratorFastExcel($model,$sort) {
        $data=TraceTest::where('model',$model)->where('serial',$sort)->where('is_lowest',1)
            ->select('model','security_code','code')->cursor();
        foreach ($data as $value) {
            yield $value;
        }
    }

    public function exportFastExcel(Request $request){
        $serial=Serial::outsideLog()->where('id',$request->input('id'))->first();
        if($serial->status==0){
            return $this->error('450001','正在生成数据，请稍后再次操作');
        }
        if($serial->down_status!=0){
            return $this->error('450001','文件正在生成中或已生成');
        }
        if($serial->id <= 67){
            $model=$serial->model;
            $new_model=str_replace(":","_",$model);
            $sort=$serial->sort;
            $filename = '第'.$sort.'批-类型'.$new_model.'-数量'.$serial->num.'组.csv';
            Serial::where('id',$serial->id)->update([
                'down_status'=>2,
                'down_url'=>env('APP_URL').'/storage/trace/model'.$new_model.'/'.$filename
            ]);
        }else{
            DownloadFileJob::dispatch($serial);//['sort'=>$serial->sort,'model'=>$serial->model,'num'=>$serial->num]
            $serial->down_status=1;//正在生成中。。。
            $serial->save();
        }
        return $this->success([]);
    }

    public function refreshDownload(Request $request){
        $id=$request->input('id');
        $serial=Serial::outsideLog()->where('id',$id)->first();
        return $this->success($serial);
    }

    public function getDownloadLog(Request $request){
        $id=$request->input('id');
        $log=Serial::where('id',$id)->value('down_log');
        return $this->success($log);
    }

    public function downloadFileLog(Request $request){
        $id=$request->input('id');
        $serial=Serial::where('id',$id)->first();
        $arr=json_decode($serial->down_log,true);
        $arr=$arr?$arr:[];
        $log=['admin_id'=>Auth::user()->id,'admin_name'=>Auth::user()->name,'time'=>Carbon::now()->toDateTimeString()];
        array_push($arr,$log);
        $serial->down_log=json_encode($arr,JSON_UNESCAPED_UNICODE);
        $serial->down_num=count($arr);
        $serial->save();
        return $this->success([]);
    }

//    public function exportFastExcel(Request $request){
//        $serial=Serial::where('id',$request->input('id'))->first();
//        $model=$serial->model;
//        $sort=$serial->sort;
//        $path=storage_path().'/app/public/trace/';
//        $filename = '第'.$sort.'批-类型'.str_replace(":","_",$model).'-数量'.$serial->num.'组.csv';
//        $file =$path.$filename;
//        if(!Storage::exists('trace/'.$filename)){
//            (new FastExcel($this->usersGeneratorFastExcel($model,$sort)))
//                ->export($file, function ($order) {
//                    return [
//                        '大码' => $order['max_code'] . "\t",
//                        '中码' => $order['sec_code'] . "\t",
//                        '小码' => $order['code'] . "\t",
//                        '防伪码' => $order['security_code'] . "\t",
//                        '类型' => $order['model'] . "\t",
//                    ];
//                });
//        }
//        $url = env('APP_URL').'/storage/trace/'.$filename;
//        return $this->success($url);
//    }

    //测试生成10000组
    public function BatchProductionCode(Request $request){
        ini_set('memory_limit', '10240000M');
        $input=$request->all();
        $total=$input['total'];
        $model=$input['model'];
        $grade=TraceTest::$model[$model]['grade'];
        $num=TraceTest::$model[$model]['num'];
//        if($total>3000){
//            return $this->error('一次最多生成3000组');
//        }
        if($grade>3){
            $grade=3;
        }
        $serial=Serial::where('model',$model)->max('sort');
        if(empty($serial)){
            $serial=1;
        }else{
            $serial+=1;
        }
        Serial::create([
            'sort'=>$serial,
            'num'=>$total,
            'model'=>$model,
            'status'=>0
        ]);
        if($grade>=1){
            $mes['grade']=$grade;
            $mes['num']=$num;
            $mes['total']=100;  //100
            $mes['model']=$model;
            $mes['serial'] = $serial;
            $t=floor($total/100); //向下取整   100
            $n=$total%100; //取模  100
            Log::info($n.'/'.$t);
            CrossTraceTest::dispatch(['grade'=>$grade,'num'=>$num,'total'=>$n,'model'=>$model,'serial'=>$serial]);
            for($a=0;$a<$t;$a++){
                CrossTraceTest::dispatch($mes);
            }
            SerialStatus::dispatch(['model'=>$model,'sort'=>$serial]);
        }
        return $this->success([]);
    }

    public function exportSimple123(Request  $request){
//FastExcel 导出文件
        $file = 'order.csv';
        (new FastExcel($this->usersGenerator()))
            ->export($file, function ($order) {
                return [
                    '类型' => $order['model'] . "\t",
                    '短码' => $order['security_code'] . "\t",
                    '小码' => $order['code'] . "\t",
                    '中码' => $order['sec_code'] . "\t",
                    '大码' => $order['max_code'] . "\t",
                ];
            });
        exit;
//viest/php-ext-xlswriter-ide-helper 导出文件
        $config = ['path' => 'C:\Users\001\Desktop\音乐'];
        $excel  = new \Vtiful\Kernel\Excel($config);
        $data=TraceTest::query()
            ->whereIn('serial',['16','17','18','19'])
            ->where('is_lowest','1')
            ->select('model','security_code','code')
            ->orderBY('code','desc')->limit(40000)->cursor();
        $new_data = [];
        //关联数组转换为索引数组
        foreach ($data as $value) {
            $new_data[] = array_values($value);
        }
        $rows=['类别','fwm','小码','中码','大码'];
        $filePath = $excel->fileName('tutorial06.xlsx', 'sheet1')
            ->header(['类别', 'fwm', '小码', '中码', '大码'])
            ->data($new_data)
            ->output();
        exit;
//laravel 导出文件
        $list=TraceTest::query()
            ->whereIn('serial',['16','17','18','19'])
            ->where('is_lowest','1')
            ->select('model','security_code','code')
            ->orderBY('code','desc')->limit(10)->get()->toArray();
        $rows=[['类别', 'fwm', '小码', '中码', '大码']];
        return Excel::download(new TraceTestExport($list,$rows), '防伪码test.csv');
    }

//    public function export(){
//        ini_set('memory_limit', '10240000M');
//        $list=Trace::where('pid',0)
//            ->with(['get_child'=>function($query){
//                $query->with(['get_child'=>function($q){
//                    $q->select('id','code','security_code','pid','level')
//                        ->orderBy('id');
//            }])->select('id','code','security_code','pid','level')
//                    ->orderBy('id');
//        }])->select('id','code','security_code','pid','level')
//            ->orderBy('id')
//            ->limit(1000)
//            ->get()->toArray();
//        $row=[[
//            "id"=>'ID',
//            "code"=>'CODE',
//            "security_code"=>'防伪码',
//            "pid"=>'PID',
//            "level"=>'等级'
//        ]];
//
//        return Excel::download(new TraceExport($row,$list), '防伪码.csv');
//    }

    public function getTraceExportUrl(Request $request){
        $input=$request->all();
        $id=$input['id'];
        $serial=Serial::where('id',$id)->first();

        $status=Serial::where('model',$serial->model)->where('sort',$serial->sort)->value('status');
        if($status==0){
            return $this->error('450001','正在生成数据，请稍后再次操作');
        }
        $url = env('APP_URL').'/api/trace/export';
        $data='?model='.$serial->model.'&serial='.$serial->sort;
        return $this->success($url.$data);
    }

    public function getTraceAndInfo(Request $request){
        ini_set('memory_limit', '1024M');
        $input=$request->all();
        $model=$input['model'];
        $serial=$input['serial'];
        $status=Serial::where('model',$model)->where('sort',$serial)->value('status');
        $num=Serial::where('model',$model)->where('sort',$serial)->value('num');
        if($status==0){
            return $this->error('450001','data is ing');
        }
        $row=[
            "code"=>'长链接',
            "security_code"=>'防伪码',
            "pid"=>'父类序号',
            "sort"=>'序列号',
            "model"=>'类型',
            "level"=>'等级'
        ];
        $rows=[
            "max_code"=>'大码',
            "sec_code"=>'中码',
            "min_code"=>'小码',
            "security_code"=>'防伪码',
            "model"=>'类型',
        ];
        if ($model=='1:10' || $model=='1:12'){
            $re=Trace::where('model',$model)->where('serial',$serial)
                ->limit('150000')->orderBy('sort')->where('level',1)->with(['get_childs'=>function($q){
                    $q->where('level',2);
                }])->get();
            $arr=[];
            $i=0;
            foreach ($re as $k=>$v){
                $str='';
                $str_m='';
                $str_code='';
                if ($v->model=='1:10' ||  $v->model=='1:12'){
                    foreach ($v->get_childs as $ke=>$va){
                        $str=env('APP_TRACE').$va->code;
                        $str_code=$va->security_code;
                        $arr[$i]['max_code']=env('APP_TRACE').$v->code;
                        $arr[$i]['sec_code']='';
                        $arr[$i]['min_code']=$str;
                        $arr[$i]['security_code']=$str_code;
                        $arr[$i]['model']=$model;
                        $i++;
                    }

                }else{
                    $res=Trace::where('model',$model)->where('serial',$serial)
                        ->where('pid',$v->sort)->get();
                    foreach ($res as $ke=>$va){
                        $ress=Trace::where('model',$model)->where('serial',$serial)
                            ->where('pid',$va->sort)->get();
                        foreach ($ress as $key=>$val){
                            $str.=env('APP_TRACE').$val->code.',';
                            $str_code.=$val->security_code.',';
                        }
                        $str_m.=env('APP_TRACE').$va->code.',';
                    }
                    $arr[$k]['max_code']=env('APP_TRACE').$v->code;
                    $arr[$k]['sec_code']=$str_m;
                    $arr[$k]['min_code']=$str;
                    $arr[$k]['security_code']=$str_code;
                    $arr[$k]['model']=$model;
                }
            }
        }else{
            $re=Trace::where('model',$model)->where('serial',$serial)
                ->limit('150000')->orderBy('sort')->where('level',1)->with(['get_childs'=>function($q){
                    $q->where('level',2)->with(['get_childs'=>function($q){
                        $q->where('level',3);
                    }]);
                }])->get();
            $i=0;
            $arr=[];
            foreach ($re as $k=>$v){
                $str='';
                $str_m='';
                $str_code='';
                foreach ($v->get_childs as $ke=>$va){
                    $str_m=env('APP_TRACE').$va->code;
                    foreach ($va->get_childs as $key=>$val){
                        $str=env('APP_TRACE').$val->code;
                        $str_code=$val->security_code;
                        $arr[$i]['max_code']=env('APP_TRACE').$v->code;
                        $arr[$i]['sec_code']=$str_m;
                        $arr[$i]['min_code']=$str;
                        $arr[$i]['security_code']=$str_code;
                        $arr[$i]['model']=$model;
                        $i++;
                    }
                }
            }
        }


//       $list =Trace::where('model',$model)->where('serial',$serial)
//           ->limit('150000')->orderBy('sort')->get()->toArray();
        $filename='第'.$serial.'批-类型'.$model.'-'.'数量'.$num.'组.csv';
        header('Content-Description: File Transfer');
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment; filename="'. $filename .'"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        $fp = fopen('php://output', 'a');//打开output流
        mb_convert_variables('GBK', 'UTF-8', $rows);
        fputcsv($fp, $rows);
        foreach ($arr as $db){
            $data=[$db['max_code'],$db['sec_code'],$db['min_code'],$db['security_code'],$db['model']];
//            $data=[env('APP_TRACE').$db['code'],$db['security_code'],$db['pid'],$db['sort'],$db['model'],$db['level']];
            mb_convert_variables('GBK', 'UTF-8', $data);
            fputcsv($fp, $data);
        }
        unset($dbs);
        ob_flush();
        flush();
        fclose($fp);
        exit();
    }

    //        ini_set('memory_limit', '10240000M');
//        $list=Trace::where('pid',0)
//            ->with(['get_child'=>function($query){
//                $query->with(['get_child'=>function($q){
//                    $q->select('id','code','security_code','pid','level');
//                }])->select('id','code','security_code','pid','level');
//            }])->select('id','code','security_code','pid','level')
//            ->limit(3000)
//            ->get()->toArray();
//
//        $row=[[
//            "id"=>'ID',
//            "code"=>'CODE',
//            "security_code"=>'防伪码',
//            "pid"=>'PID',
//            "level"=>'等级'
//        ]];
//
//        $key_arr=[];
//        foreach ($row[0] as $key => $value) {
//            $key_arr[] = $key;
//        }
//
//        foreach ($list as $keys => $value) {
//            $js = [];
//            for ($i=0; $i < count($key_arr); $i++) {
//                if($key_arr[$i]=='code'){
//                    $js =array_merge($js, [$key_arr[$i] => env('APP_URL').(string)$value[$key_arr[$i]]]);
//                }else{
//                    $js =array_merge($js, [$key_arr[$i] => (string)$value[$key_arr[$i]]]);
//                }
//            }
//            $row[]=$js;
//            if($value['get_child']){
//                foreach($value['get_child'] as $key=>$val){
//                    $js = [];
//                    for ($j=0; $j < count($key_arr); $j++) {
//                        if($key_arr[$j]=='code'){
//                            $js =array_merge($js, [$key_arr[$j] => env('APP_URL').(string)$val[$key_arr[$j]]]);
//                        }else{
//                            $js =array_merge($js, [$key_arr[$j] => (string)$val[$key_arr[$j]]]);
//                        }
//                    }
//                    $row[]=$js;
//                    if($val['get_child']){
//                        foreach($val['get_child'] as $k=>$v){
//                            $js=[];
//                            for ($z=0; $z < count($key_arr); $z++) {
//                                if($key_arr[$z]=='code'){
//                                    $js =array_merge($js, [$key_arr[$z] => env('APP_URL').(string)$v[$key_arr[$z]]]);
//                                }else{
//                                    $js =array_merge($js, [$key_arr[$z] => (string)$v[$key_arr[$z]]]);
//                                }
//                            }
//                            $row[]=$js;
//                        }
//                    }
//                }
//            }
//        }

    /*
     * 查看发货记录
     * **/
    public function GetSendGoodLog(Request $request){
        $input=$request->all();
        $page_index=$input['page_index'];
        $page_size=$input['page_size'];
        $search_name=$input['search_name'];
        $op_phone=$input['op_phone'];
        $code=$input['code'];
        $start_time=$input['start_time'];
        $end_time=$input['end_time'];
        $good_select_id=$input['good_select_id'];
        $re=SendGoodLog::where('type',0);
        if ($search_name){
            $ids=User::where('mobile','like',"%$search_name%")->orwhere('nickname','like',"%$search_name%")->pluck("id");
            $re->whereIn('accept_id',$ids);
        }
        if ($op_phone){
            $re->where('op_phone',$op_phone);
        }
        if ($code){
            $code_id=Trace::where('code',$code)->value('id');
            $re->where('select_id',$code_id);
        }
        if ($start_time){
            $re->whereBetween('created_at',[$start_time,$end_time]);
        }
        $re->whereHas('code',function ($query)use($good_select_id) {
            if ($good_select_id){
                $query->where('good_select_id',$good_select_id);
            }

        },'=','1')
            ->with(['code'=>function($q){
            $q->with(['get_goods'=>function($qu){
                $qu->select('good_name','id');
            }]);
        }]);
        $re=$re->paginate($page_size,null,'page_index');
        $data=[];
        foreach ($re as $k=>$v){
            $data[$k]=$v;
            if ($v->code->is_lowest==1){
                $data[$k]->code->all_childnum=1;
                $data[$k]->code->code_level='小码';
            }else{
                if ($v->code->model=='1:10'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=10;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:12'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=12;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:6:24'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=24;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=4;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }elseif ($v->code->model=='1:6:36'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=36;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=6;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }
            }
        }
       return $this->success_list($re->items(),'',$re->total());
    }

    public function ExportSendGoodLog(Request $request){
        $input=$request->all();
        $search_name=$input['search_name'];
        $op_phone=$input['op_phone'];
        $code=$input['code'];
//        $start_time=$input['start_time'];
//        $end_time=$input['end_time'];
        $start_time=$input['time'][0];
        $end_time=$input['time'][1];
        $good_select_id=$input['good_select_id'];
        $re=SendGoodLog::where('type',0);
        if ($search_name){
            $ids=User::where('mobile','like',"%$search_name%")->orwhere('nickname','like',"%$search_name%")->pluck("id");
            $re->whereIn('accept_id',$ids);
        }
        if ($op_phone){
            $re->where('op_phone',$op_phone);
        }
        if ($code){
            $code_id=Trace::where('code',$code)->value('id');
            $re->where('select_id',$code_id);
        }
        if ($start_time){
            $re->whereBetween('created_at',[$start_time,$end_time]);
        }
        $re->whereHas('code',function ($query)use($good_select_id) {
            if ($good_select_id){
                $query->where('good_select_id',$good_select_id);
            }

        },'=','1')
            ->with(['code'=>function($q){
                $q->with(['get_goods'=>function($qu){
                    $qu->select('good_name','id');
                }]);
            }]);
        $re=$re->get();
        $data=[];
        foreach ($re as $k=>$v){
            $data[$k]=$v;
            if ($v->code->is_lowest==1){
                $data[$k]->code->all_childnum=1;
                $data[$k]->code->code_level='小码';
            }else{
                if ($v->code->model=='1:10'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=10;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:12'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=12;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:6:24'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=24;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=4;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }elseif ($v->code->model=='1:6:36'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=36;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=6;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }
            }
        }
        return $this->success($re);
    }

    public function sel(){
//        $data=Express::where('created_at','>=','2021-03-11 00:00:00')->where('express_code','<>','ZTOKY')->select('*')->groupBy('express_number')->havingRaw('count(express_number) > ?',[1])->get();
//        $order_arr=Express::where('created_at','>=','2021-03-11 00:00:00')->orderByDesc('id')->where('express_code','<>','ZTOKY')->select('*')->groupBy('express_number')->havingRaw('count(express_number) > ?',[1])->pluck('order_id');
//        foreach ($data as $k=>$v){
//            Express::where('express_number',$v->express_number)->limit(1)->orderByDesc('id')->delete();
//        }
//        $arr=array_unique($order_arr->toArray());
        $arr=Express::whereBetween('id',['10901','14262'])->groupBy('order_id')->pluck('order_id');
        foreach ($arr as $k=>$v){
           $re=Express::where('order_id',$v)->orderBy('created_at')->groupBy('created_at')->get();
           foreach ($re as $ke=>$va){
               Express::where("order_id",$v)->where("created_at",$va->created_at)->update(['number'=>$ke+1]);
           }
           $total=Express::where("order_id",$v)->sum('total');
           $Number=Express::where("order_id",$v)->count();
           $res=Ordertest::find($v);
           if ($res->total==$total){
               $res->track_status=2;
               $res->put_status=1;
           }else{
               $res->track_status=1;
               $res->put_status=0;
           }
           $res->number=$Number;
           $res->save();
        }
        dd(1);
    }

    /*
    * 查看发货记录
    * **/
    public function GetExceptionSendGoodLog(Request $request){
        $input=$request->all();
        $page_index=$input['page_index'];
        $page_size=$input['page_size'];
        $search_name=$input['search_name'];
        $code=$input['code'];
        $start_time=$input['start_time'];
        $end_time=$input['end_time'];
        $scan_type=$input['scan_type'];
        $re=SendGoodLog::where('type',0);
        if ($search_name){
            $ids=User::where('mobile','like',"%$search_name%")->orwhere('nickname','like',"%$search_name%")->pluck("id");
            $re->whereIn('accept_id',$ids);
        }
        if ($scan_type){
            $re->where('scan_type',$scan_type);
        }
        if ($code){
            $code_id=Trace::where('code',$code)->value('id');
            $re->where('select_id',$code_id);
        }
        if ($start_time){
            $re->whereBetween('created_at',[$start_time,$end_time]);
        }
        $re->with(['code'=>function($q){
                $q->with(['get_goods'=>function($qu){
                    $qu->select('good_name','id');
                }]);
            }])->with(['before_user:id,nickname']);
        $re=$re->orderByDesc('id')->paginate($page_size,null,'page_index');
        $data=[];
        foreach ($re as $k=>$v){
            $data[$k]=$v;
            if ($v->code->is_lowest==1){
                $data[$k]->code->all_childnum=1;
                $data[$k]->code->code_level='小码';
            }else{
                if ($v->code->model=='1:10'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=10;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:12'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=12;
                        $data[$k]->code->code_level='大码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }

                }elseif ($v->code->model=='1:6:24'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=24;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=4;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }elseif ($v->code->model=='1:6:36'){
                    if ($v->code->level==1){
                        $data[$k]->code->all_childnum=36;
                        $data[$k]->code->code_level='大码';
                    }elseif ($v->code->level==2){
                        $data[$k]->code->all_childnum=6;
                        $data[$k]->code->code_level='中码';
                    }else{
                        $data[$k]->code->all_childnum=1;
                        $data[$k]->code->code_level='小码';
                    }
                }
            }
        }
        return $this->success_list($re->items(),'',$re->total());
    }
}
