<?php

namespace Modules\Manager\Jobs\Qy;

use App\Models\DHMoneyPct;
use App\Models\Orderdetail;
use App\Models\Ordertest;
use App\Models\QYMoneyDetail;
use App\Models\QYUserMoney;
use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Support\Facades\DB;

class ReckonOrderCrownMoneyMonthJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    protected $data;
    public function __construct($data)
    {
        $this->data=$data;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {

        /*
         * 计算每个月代理公司的下单金额，并扣除需要奖励的金额
         * ***/
        $data=$this->data;
        $time=$data['year'].'-'.$data['month'];
        $time_start=Carbon::parse($time)->startOfMonth();
        $time_end=Carbon::parse($time)->endOfMonth();

        /*此月份的下单人**/
        $order=Ordertest::whereBetween('created_at',[$time_start,$time_end])->where('is_deleted',0)->groupBy('user_id')->get();

        foreach ($order as $k=>$v){
            /*本下单人此月的金额**/
            $money=Ordertest::whereBetween('created_at',[$time_start,$time_end])
                ->where('is_deleted',0)->where('user_id',$v->user_id)->sum('money');

            /**此月本人的订单ID**/
            $order_id=Ordertest::whereBetween('created_at',[$time_start,$time_end])
                ->where('is_deleted',0)->where('user_id',$v->user_id)->pluck('id');

            /**根据订单详情计算金额**/
            $orderDetail=Orderdetail::whereIn('order_id',$order_id)->groupBy('goods_name')
                ->select(\DB::raw('sum(money) as money'),'goods_price','goods_unit',DB::raw('sum(num) as num'),'goods_name')->get();

            /*返现的规则
             * ***/
            $re=DHMoneyPct::where('money_start','<',$money)->where('money_end','>',$money)->orderBy('id')->get();
//            $re=DHMoneyPct::where('time_start','<',$time_end)->where('time_end','>',$time_end)->orderBy('id')->get();
            $n=0;

            /*根据规则计算当前金额应该返现的比例
             * **/
            foreach ($re as $ke=>$va){
//                if ($ke==0){
//                    if ($money<$va->money_start){
//                        $n=0;
//                        break;
//                    }
//                }
//                if ($money>=$va->money_start && $money<$va->momey_end){
//                    $n=$va->pct;
//                    break;
//                }
                if ($va->time_start<$time && $time<$va->time_end){
                    $n=$va->pct;
                }
            }


            /**将用户的总金额记录一下**/
            $user_money=new QYUserMoney ();
            $user_money->user_id=$v->user_id;
            $user_money->money=$money;
            $user_money->pct_money=$money*(1-$n);//记录返现后的单价
            $user_money->year=Carbon::parse($time_end)->year;
            $user_money->month=Carbon::parse($time_end)->month;//记录当前时间的月份
            $user_money->save();

            /**记录每种商品的价格*/
            foreach ($orderDetail as $ke=>$va){
                $detail=new QYMoneyDetail();
                $detail->qy_usermoney_id=$user_money->id;
                $detail->price=$va->goods_price*(1-$n);//返现后的实际价格
                $detail->unit=$va->goods_unit;
                $detail->num=$va->num;
                $detail->good_name=$va->goods_name;
                $detail->money=$va->money*(1-$n);//返现后的实际金额
                $detail->save();
            }

        }
    }
}
