<?php

namespace Modules\Manager\Jobs\Qy;

use App\Handlers\BigMoneyHnadler;
use App\Models\QYCrownDocumet;
use App\Models\QYUserAuth;
use App\Models\QYUserMoney;
use App\Models\User;
use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Support\Facades\Log;
use TencentCloud\Common\Credential;
use TencentCloud\Common\Exception\TencentCloudSDKException;
use TencentCloud\Common\Profile\ClientProfile;
use TencentCloud\Common\Profile\HttpProfile;
use TencentCloud\Sms\V20190711\Models\SendSmsRequest;
use TencentCloud\Sms\V20190711\SmsClient;

class SendQYMonthMoneyInfoJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    protected $data;
    public function __construct($data)
    {
        $this->data=$data;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $data=$this->data;

        Log::error($data);
        foreach ($data as $k=>$v) {
            Log::info($v);
            try {

                $sdkClient = \Util::getSDk();

                /* 合同基本信息 */
                $contract = new \Contract();
                $contract->setSubject($v['realname'] . '的' . $v['month'] . '月份合同');
                $contract->setOrdinal(true);
                $contract->setSend(true);
                /*指定业务分类\*\*/
                $category = new \Category();
                $category->setName("公司对个人");
                $contract->setCategory($category);
                $creator = new \User();
                $creator->setContact("15286818088");
                $creator->setContactType("MOBILE");
                $contract->setCreator($creator);
//        /*公司签署方\*\*/
                $companySignatory = new \Signatory();
                $companySignatory->setTenantType("COMPANY");
                $companySignatory->setTenantName("大卫博士");
                $companySignatory->setReceiver("大卫博士");
                $companySignatory->setSerialNo(1);
                /*公司签署方接收人\*\*/
                $receiver = new \User();
                $receiver->setContact("4006867733");
                $receiver->setContactType("MOBILE");
                $companySignatory->setReceiver($receiver);
//        /*公章签署动作\*\*/
                $companyAction = new \Action();
                $companyAction->setType("COMPANY");
                $companyAction->setName("公章签署动作");
                $companyAction->setSerialNo(1);
                $actions = array();
                /*公司签署方设置公章签署动作\*\*/
                array_push($actions, $companyAction);

                $companySignatory->setActions($actions);
//        /*个人签署方\*\*/
                $personalSignatory = new \Signatory();
                $personalSignatory->setTenantType("PERSONAL");
                $personalSignatory->setTenantName($v['realname']);
                $personalSignatory->setSerialNo(2);
                $receiver = new \User();
                $receiver->setContact($v['mobile']);
                $receiver->setContactType("MOBILE");
                $personalSignatory->setReceiver($receiver);
                Log::error(1);
//        /*所有签署方\*\*/
                $signatories = array();
                array_push($signatories, $companySignatory);
                array_push($signatories, $personalSignatory);
                /*填写模板参数\*\*/
                $templateParam1 = new \TemplateParam();
                $templateParam1->setName("参数1");
                $templateParam1->setValue($v['realname']);
                $templateParam10 = new \TemplateParam();
                $templateParam3 = new \TemplateParam();
                $templateParam4 = new \TemplateParam();
                $templateParam5 = new \TemplateParam();
                $templateParam6 = new \TemplateParam();
                $templateParam7 = new \TemplateParam();
                $templateParam8 = new \TemplateParam();
                $templateParam9 = new \TemplateParam();
                $templateParam2 = new \TemplateParam();
                $templateParam2->setName("参数2");
                $templateParam2->setValue($v['realname']);
                $templateParam3->setName("参数4");
                $templateParam3->setValue($v['cre_num']);
                $templateParam4->setName("参数5");
                $templateParam4->setValue($v['money']);
                $templateParam5->setName("参数6");
                $templateParam5->setValue(Carbon::now()->toDateString());
                $templateParam6->setName("参数7");
                $templateParam6->setValue(Carbon::now()->toDateString());
                $templateParam7->setName("参数8");
                $document_num='DWBSGX-'.$v['month'].'-'.random_int(1111, 9999) . date('ymd',time()).mb_substr(Carbon::now()->getPreciseTimestamp(3),8);
                $templateParam7->setValue($document_num);
                $templateParam8->setName("参数9");
                $templateParam8->setValue($this->MakeMoney($v['money']));
                $templateParam9->setName("参数10");
                $templateParam9->setValue("");
                $templateParam10->setName("表格1");
                $templateParam10->setValue($v['data']);
                $templateParams = array();
                array_push($templateParams, $templateParam1, $templateParam2, $templateParam3, $templateParam4, $templateParam5, $templateParam6
                    , $templateParam7, $templateParam8, $templateParam9, $templateParam10);
                /*合同签署方、文档、文档参数\*\*/
                $contract->setSignatories($signatories);
                $contract->setTemplateParams($templateParams);
//        dd($signatories);
                $baseRequest = new \ContractDraftRequest($contract);
                $result = $sdkClient->service($baseRequest);
                Log::error($result);
                if (isset($result['result']['status'])) {
                    /*
                     * 获取短链
                     * **/
                    $sdkClient = \Util::getSDk();
                    $baseRequest = new \ContractShorturlRequest();
                    $baseRequest->setContractId($result['result']['id']);
                    $results = $sdkClient->service($baseRequest);
                    Log::error($results);

                    /*
                     * 保存合同信息
                     * **/
                    $document = new QYCrownDocumet();
                    $document->pact_id = $result['result']['id'];
                    $document->shortLink = $results['result']['shorturl'];
                    $document->document_id = $result['result']['documents'][0]['id'];
                    $document->time_out = $result['result']['expireTime'];
                    $document->month = $v['month'];
                    $document->year = $v['year'];
                    $document->user_id = $v['user_id'];
                    $document->document_num=$document_num;
                    $document->title = $v['realname'] . '的' . $v['month'] . '月份合同';
                    $document->save();
                    $usermoney = QYUserMoney::where('id', $v['id'])->first();
                    $usermoney->document_id = $document->id;
                    $usermoney->save();
                    $this->SendSms($document->id);
                }
            } catch (\Exception $exception) {
                Log::info($exception->getMessage());
            }
        }
    }

    /*
     * 金额转大写
     * **/
    public function MakeMoney($money){
        $bigMoneyHnadler=new BigMoneyHnadler();
       return $bigMoneyHnadler->withoutPrefix()->convert($money);
    }

    /*
     * 发送模板消息
     * ***/

    public function sendWechat($id){
        $user=User::find($id);
        $template_id='';
        $app=app('wechat.official_account');
        if ($user->openid){
            $app->template_message->send([
                'touser' => $user->openid,
                'template_id' => $template_id,
                'url' => $document->shortLink,
                'data' => []
            ]);
        }
    }


    /*
     * 发送短信
     * ***/

    public function SendSms($id){
        $data=QYCrownDocumet::find($id);
        $mobile=QYUserAuth::where('user_id',$data->user_id)->value('mobile');
        try {
            /* 必要步骤：
             * 实例化一个认证对象，入参需要传入腾讯云账户密钥对secretId，secretKey。
             * 这里采用的是从环境变量读取的方式，需要在环境变量中先设置这两个值。
             * 你也可以直接在代码中写死密钥对，但是小心不要将代码复制、上传或者分享给他人，
             * 以免泄露密钥对危及你的财产安全。
             * CAM密匙查询: https://console.cloud.tencent.com/cam/capi*/

            $cred = new  Credential('AKIDtZz93Rj3LOoyiEseU9YgZDbiZAcpoTu4','7ya0C7nDNHuHRLyLjrkPoxrVt2ZqQnul');
            //$cred = new Credential(getenv("TENCENTCLOUD_SECRET_ID"), getenv("TENCENTCLOUD_SECRET_KEY"));

            // 实例化一个http选项，可选的，没有特殊需求可以跳过
            $httpProfile = new HttpProfile();
            $httpProfile->setReqMethod("POST");  // post请求(默认为post请求)
            $httpProfile->setReqTimeout(30);    // 请求超时时间，单位为秒(默认60秒)
            $httpProfile->setEndpoint("sms.tencentcloudapi.com");  // 指定接入地域域名(默认就近接入)

            // 实例化一个client选项，可选的，没有特殊需求可以跳过
            $clientProfile = new ClientProfile();
            $clientProfile->setSignMethod("TC3-HMAC-SHA256");  // 指定签名算法(默认为HmacSHA256)
            $clientProfile->setHttpProfile($httpProfile);

            // 实例化要请求产品(以sms为例)的client对象,clientProfile是可选的
            $client = new SmsClient($cred, "ap-shanghai", $clientProfile);

            // 实例化一个 sms 发送短信请求对象,每个接口都会对应一个request对象。
            $req = new SendSmsRequest();

            /* 填充请求参数,这里request对象的成员变量即对应接口的入参
             * 你可以通过官网接口文档或跳转到request对象的定义处查看请求参数的定义
             * 基本类型的设置:
             * 帮助链接：
             * 短信控制台: https://console.cloud.tencent.com/sms/smslist
             * sms helper: https://cloud.tencent.com/document/product/382/3773 */

            /* 短信应用ID: 短信SdkAppid在 [短信控制台] 添加应用后生成的实际SdkAppid，示例如1400006666 */
            $req->SmsSdkAppid = "1400258913";
            /* 短信签名内容: 使用 UTF-8 编码，必须填写已审核通过的签名，签名信息可登录 [短信控制台] 查看 */
            $req->Sign = "大卫博士";
            /* 短信码号扩展号: 默认未开通，如需开通请联系 [sms helper] */
            $req->ExtendCode = "0";
            /* 下发手机号码，采用 e.164 标准，+[国家或地区码][手机号]
             * 示例如：+8613711112222， 其中前面有一个+号 ，86为国家码，13711112222为手机号，最多不要超过200个手机号*/
            $req->PhoneNumberSet = ['+86'.$mobile];
            /* 国际/港澳台短信 senderid: 国内短信填空，默认未开通，如需开通请联系 [sms helper] */
//            $req->SenderId = "xxx";
            /* 用户的 session 内容: 可以携带用户侧 ID 等上下文信息，server 会原样返回 */
            $req->SessionContext = "您有一份新的订货合同需要签署，合同标题为：{1}年{2}月订货合同。请尽快点击链接进行签署。 链接地址为：https://t.qiyuesuo.cn/{3}";
            /* 模板 ID: 必须填写已审核通过的模板 ID。模板ID可登录 [短信控制台] 查看 */
            $req->TemplateID = "1329096";
            /* 模板参数: 若无模板参数，则设置为空*/
            $req->TemplateParamSet = [$data->year,$data->month,mb_substr($data->shortLink,22)];


            // 通过client对象调用DescribeInstances方法发起请求。注意请求方法名与请求对象是对应的
            // 返回的resp是一个DescribeInstancesResponse类的实例，与请求对象对应
            $resp = $client->SendSms($req);

        }
        catch(TencentCloudSDKException $e) {
        }
    }
}
