<?php

namespace Modules\Manager\Listeners;

use Modules\Manager\Events\AddService;
use App\Models\UserZ;
use Illuminate\Support\Facades\Log;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;

class AddServiceListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  AddService  $event
     * @return void
     */
    public function handle(AddService $event)
    {
        $admin=$event->user;
        $userZ=UserZ::where('phone',$admin->mobile)->first();
        if(!isset($admin->before)){
            UserZ::create([
                'phone'=>$admin->mobile,
                'nickname'=>$admin->name,
                'level_name'=>'政委',
            ]);
        }else{
            $id=UserZ::where('level_name','政委')->where('phone',$admin->before)->value('id');
            UserZ::where('id',$id)->update([
                'phone'=>$admin->mobile,
                'nickname'=>$admin->name,
                'level_name'=>'政委',
            ]);
            UserZ::where('up_phone',$admin->before)->where('level_name','政委')->update([
                'up_phone'=>$admin->mobile,
                'up_name'=>$admin->name,
            ]);
        }
        Log::info('添加政委'.$admin->id);
    }
}
