<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/
$api = app('Dingo\Api\Routing\Router');
$api->version('v1', function ($api) {
    $api->group(['namespace' => 'Modules\Manager\Http\Controllers'], function ($api) {
        /* 后台账号管理 */
        $api->group(['prefix' => 'admin'], function ($api) {
            $api->post('decode', 'AdminController@decode');
            $api->post('uploadadmin', 'AdminController@uploadAdmin');
            $api->post('updateadmin', 'AdminController@updateAdmin');
            $api->get('getadminlist', 'AdminController@getAdminList');
            $api->post('disableadmin', 'AdminController@disableAdmin');
            $api->post('destoryadmin', 'AdminController@destoryAdmin');
        });

        /* 角色路由 */
        $api->group(['prefix' => 'role'], function ($api) {
            $api->post('uploadrole', 'RoleController@uploadRole');
            $api->get('getroleslist', 'RoleController@getRolesList');
            $api->post('disablerole', 'RoleController@disableRole');
            $api->post('updaterole', 'RoleController@updateRole');
        });

        /*服务路由*/
        $api->group(['prefix' => 'warea'], function ($api) {
            $api->get('getwarealist', 'WareaController@getWareaList');
            $api->post('updatewarea', 'WareaController@updateWarea');
            $api->post('uploadwarea', 'WareaController@uploadWarea');
            $api->post('shelvedwarea', 'WareaController@shelvedWarea');
            $api->post('destorywarea', 'WareaController@destoryWarea');
            $api->get('getcommissarlist', 'WareaController@getCommissarList');
            $api->get('getcommissarinfo', 'WareaController@getCommissarInfo');
        });

        /* 助手路由 */
        $api->group(['prefix' => 'assit'], function ($api) {
            $api->get('getAssitList', 'AssitController@getAssitList');
            $api->get('getUser', 'AssitController@getUser');
            $api->post('addAssit', 'AssitController@addAssit');
            $api->post('editAssit', 'AssitController@editAssit');
            $api->post('delAssit', 'AssitController@delAssit');
        });

        /* 设置路由 */
        $api->group(['prefix' => 'setting'], function ($api) {
            $api->get('getsetting', 'SettingController@getSetting');
            $api->get('GetVRLink', 'SettingController@GetVRLink');
            $api->get('SetVRLink', 'SettingController@SetVRLink');
            $api->post('uploadsetting', 'SettingController@uploadSetting');
            $api->post('updatesetting', 'SettingController@updateSetting');
            $api->post('updaterewardpay', 'SettingController@updateRewardPay');
            $api->post('updatestorereward', 'SettingController@updateStoreReward');
            $api->post('updatesystemset', 'SettingController@updateSystemSet');
            $api->post('salesreward', 'SettingController@salesReward');
            $api->post('agentuplevel', 'SettingController@agentsUpLevel');
            $api->get('GetUpgradeInfo', 'SettingController@GetUpgradeInfo');
            $api->get('UpdateUpgradeInfo', 'SettingController@UpdateUpgradeInfo');
            $api->post('UploadVideo', 'SettingController@UploadVideo');
            $api->get('GetVideo', 'SettingController@GetVideo');
            $api->get('AddVideo', 'SettingController@AddVideo');
            $api->get('UpdateVideo', 'SettingController@UpdateVideo');
            $api->get('getGoodsMain', 'SettingController@getGoodsMain');
            $api->post('updateStoreSubsidies', 'SettingController@updateStoreSubsidies');
            $api->get('getStoreSubsidies', 'SettingController@getStoreSubsidies');
            $api->post('setSubsidiesType', 'SettingController@setSubsidiesType');
            $api->get('getSubsidiesType', 'SettingController@getSubsidiesType');
        });

        /* 公告路由 */
        $api->group(['prefix' => 'info'], function ($api) {
            $api->get('getinfolist', 'InfoController@getInfoList');
            $api->post('updateinfo', 'InfoController@updateInfo');
            $api->post('uploadinfo', 'InfoController@uploadInfo');
            $api->post('setinfotop', 'InfoController@setInfoTop');
            $api->post('disableinfo', 'InfoController@disableInfo');
            $api->post('destoryinfo', 'InfoController@destoryInfo');
            $api->get('setType4Storage', 'InfoController@setType4Storage');
        });

        /* 教程路由 */
        $api->group(['prefix' => 'guide'], function ($api) {
            $api->get('getguidelist', 'GuideController@getGuideList');
            $api->post('updateguide', 'GuideController@updateGuide');
            $api->post('uploadguidefiles', 'GuideController@uploadGuideFiles');
            $api->post('uploadguide', 'GuideController@uploadGuide');
            $api->post('disableguide', 'GuideController@disableGuide');
            $api->post('destoryguide', 'GuideController@destoryGuide');
        });

        /* 公司音频路由 */
        $api->group(['prefix' => 'companyAudio'], function ($api) {
            $api->get('list', 'CompanyAudioController@list');
            $api->post('add', 'CompanyAudioController@add');
            $api->post('edit', 'CompanyAudioController@edit');
            $api->post('delete', 'CompanyAudioController@delete');
            $api->post('uploadFile', 'CompanyAudioController@uploadFile');
            $api->get('detail', 'CompanyAudioController@detail');
            $api->get('getTime', 'CompanyAudioController@getTime');
        });

        /* 版本路由 */
        $api->group(['prefix' => 'version'], function ($api) {
            $api->get('getversionlist', 'VersionController@getVersionList');
            $api->post('uploadAppVersion', 'VersionController@uploadAppVersion');
            $api->post('uploadversion', 'VersionController@uploadVersion');
            $api->post('updateversion', 'VersionController@updateVersion');
            $api->post('setversiontop', 'VersionController@setVersionTop');
            $api->post('destoryversion', 'VersionController@destoryVersion');
        });

        /* 商品路由 */
        $api->group(['prefix' => 'good'], function ($api) {
            $api->get('get_goods_attr', 'GoodtestController@getGoodsAttr');
            $api->get('GetStorageGood', 'GoodtestController@GetStorageGood');
            $api->get('good_detail', 'GoodtestController@good_detail');
            $api->get('/good_list', 'GoodtestController@good_list');
            $api->get('/good_attr', 'GoodtestController@good_attr');
            $api->post('/upload_goods_image', 'GoodtestController@uploadGoodsImage');
            $api->post('uploadgoodsimage', 'GoodtestController@uploadGoodsImage');
            $api->post('/add_good', 'GoodtestController@add_good');
            $api->get('/add_good_attr', 'GoodtestController@add_good_attr');
            $api->get('/add_money', 'UserPayController@add_money');
            $api->get('/destory_time', 'GoodtestController@destory_time');
            $api->post('/update_good', 'GoodtestController@update_good');
            $api->get('/add_size', 'GoodtestController@add_size');
            $api->get('/destory_size', 'GoodtestController@destory_size');
            $api->post('/goods_up', 'GoodtestController@goods_up');
            $api->post('/good_timing', 'GoodtestController@good_timing');
            $api->get('/get_good_attr', 'GoodtestController@get_good_attr');
            $api->post('/good_sort', 'GoodtestController@good_sort');
            $api->post('shelvedgoods', 'GoodtestController@shelvedGoods');//上架/下架
            $api->post('destorygoods', 'GoodtestController@destoryGoods');
        });

        /* 工作室商品路由 */
        $api->group(['prefix' => 'studioGood'], function ($api) {
            //获取分类
            $api->get('get_goods_attr', 'StudioGoodController@getGoodsAttr');
            //商品详情
            $api->get('good_detail', 'StudioGoodController@good_detail');
            $api->get('/good_list', 'StudioGoodController@good_list');
            $api->get('/good_attr', 'StudioGoodController@good_attr');
            $api->post('/add_good', 'StudioGoodController@add_good');
            $api->post('/update_good', 'StudioGoodController@update_good');
            $api->get('/add_size', 'StudioGoodController@add_size');
            $api->get('/destory_size', 'StudioGoodController@destory_size');
            $api->get('/get_good_attr', 'StudioGoodController@get_good_attr');
            $api->post('/good_sort', 'StudioGoodController@good_sort');
            $api->post('destorygoods', 'StudioGoodController@destoryGoods');
            $api->post('updategoods', 'StudioGoodController@updateGoods');
            $api->get('getgoodsinfo', 'StudioGoodController@getGoodsInfo');
            $api->get('uploadgoodsimage', 'StudioGoodController@uploadGoodsImage');
        });

        /* 工作室路由 */
        $api->group(['prefix' => 'studio'], function ($api) {
            $api->post('importStudio', 'StudioController@importStudio');
            $api->get('get_studio', 'StudioController@get_studio');//工作室列表
            $api->get('exportstudio', 'StudioController@exportstudio');//导出工作室
            $api->get('studio_order', 'StudioController@studio_order');//工作室订单列表
            $api->get('order_detail', 'StudioController@order_detail');//工作室订单详情
            $api->post('order_update', 'StudioController@order_update');//工作室订单修改
            $api->get('show_address', 'StudioController@show_address');//地址列表
            $api->get('order_address', 'StudioController@order_address');//修改地址
            $api->get('destory_order', 'StudioController@destory_order');//订单作废
            $api->get('orderBreakUpCourier', 'StudioController@orderBreakUpCourier');//拆单
            $api->get('set_studio_time', 'StudioController@set_studio_time');//设置兑换时间
            $api->get('get_studio_time', 'StudioController@get_studio_time');//获取兑换时间
            $api->post('importStudio', 'StudioController@importStudio');
            $api->get('GetCrownTime', 'StorageController@GetCrownTime');
            $api->get('GetStudioSystem', 'StudioController@GetStudioSystem');
            $api->get('SetStudioSystem', 'StudioController@SetStudioSystem');
            $api->post('send_order', 'StudioController@send_order');
            $api->get('SetStatusStudio', 'StudioController@SetStatusStudio');
            $api->post('AddStudio', 'StudioController@AddStudio');
            $api->post('UpdateStudio', 'StudioController@UpdateStudio');
//                $api->post('updateagentstatus', 'AuditController@updateAgentStatus');
        });

        /* 沙龙路由 */
        $api->group(['prefix' => 'sharon'], function ($api) {
            $api->get('getSharonList', 'SharonController@getSharonList');
            $api->post('authSharon', 'SharonController@authSharon');
            $api->post('cancelSharon', 'SharonController@cancelSharon');
        });

        /* 大礼包 */
        $api->group(['prefix' => 'BigGift'], function ($api) {
            $api->get('GetApplyList', 'BigGiftController@GetApplyList');
            $api->post('ApplySuccess', 'BigGiftController@ApplySuccess');
            $api->post('UpdateApply', 'BigGiftController@UpdateApply');
            $api->get('GetUserInfo', 'BigGiftController@GetUserInfo');
            $api->post('editBelongToUser', 'BigGiftController@editBelongToUser');
        });

        /* 消息推送路由 */
        $api->group(['prefix' => 'message'], function ($api) {
            $api->get('getmessagelist', 'MessageController@getMessageList');
//                $api->get('test', 'MessageController@test');
        });

        /* 检测报告 */
        $api->group(['prefix' => 'Report'], function ($api) {
            $api->post('AddUpdateReport', 'DataController@AddUpdateReport');
            $api->get('GetReport', 'DataController@GetReport');
            $api->get('GetCover', 'DataController@GetCover');
            $api->get('GetReportList', 'DataController@GetReportList');
        });

        /* 合同路由 */
        $api->group(['prefix' => 'QYInfo'], function ($api) {
            $api->get('ReckonMonthMoney', 'QYInfoController@ReckonMonthMoney');
            $api->get('GetDocumentsList', 'QYInfoController@GetDocumentsList');
            $api->get('QYAuthList', 'QYInfoController@QYAuthList');
            $api->get('QYMoneyList', 'QYInfoController@QYMoneyList');
            $api->get('QYUserMoney', 'QYInfoController@QYUserMoney');
            $api->get('SendDocument', 'QYInfoController@SendDocument');
            $api->get('GetMoneyList', 'QYInfoController@GetMoneyList');
            $api->post('AddTimeMoney', 'QYInfoController@AddTimeMoney');
            $api->post('ExportMonthMoneyList', 'QYInfoController@ExportMonthMoneyList');
            $api->get('SendSms', 'QYInfoController@SendSms');
            $api->get('Pdf', 'QYInfoController@Pdf');
            $api->get('DestroyDocument', 'QYInfoController@DestroyDocument');
            $api->post('status', 'QYInfoController@UpdateStatus');
        });

        /*店铺路由*/
        $api->group(['prefix' => 'store'], function ($api) {
            $api->get('getstorelist', 'StoreController@getStoreList');
            $api->post('updatestore', 'StoreController@updateStore');
            $api->post('uploadstore', 'StoreController@uploadStore');
            $api->post('shelvedstore', 'StoreController@shelvedStore');
            $api->post('destorystore', 'StoreController@destoryStore');
            $api->post('uploadstoreimg', 'StoreController@uploadStoreImg');
            $api->get('exportStoreSubsidies', 'StoreController@exportStoreSubsidies');

            $api->get('getAgentInfo', 'StoreController@getAgentInfo');
            $api->post('editStoreUserRate', 'StoreController@editStoreUserRate');
            $api->post('addStoreUser', 'StoreController@addStoreUser');
            $api->post('deleteStoreUser', 'StoreController@deleteStoreUser');
            $api->post('switchMan', 'StoreController@switchMan');
            $api->get('getExpStoreAgent', 'StoreController@getExpStoreAgent');
            $api->get('getExpStore', 'StoreController@getExpStore');
            $api->post('addExpStoreAgent', 'StoreController@addExpStoreAgent');
            $api->post('editExpStoreAgent', 'StoreController@editExpStoreAgent');
            $api->post('deleteExpStoreAgent', 'StoreController@deleteExpStoreAgent');
            $api->get('searchCompanyInfo', 'StoreController@searchCompanyInfo');
        });

        /* 防伪追溯 */
        $api->group(['prefix' => 'trace'], function ($api) {
            $api->get('index', 'TraceController@index');
            $api->get('get_model_info', 'TraceController@getModelInfo');
            $api->get('get_child_info', 'TraceController@getChildInfo');
            $api->post('add', 'TraceController@add');
            $api->get('getSerial', 'TraceController@getSerial');
            $api->get('getTraceInfo', 'TraceController@getTraceInfo');
            $api->get('getExpressInfo', 'TraceController@getExpressInfo');
            $api->post('destroySerial', 'TraceController@destroySerial');
            $api->get('getCodeInfo', 'TraceController@getCodeInfo');
            $api->post('many_add', 'TraceController@many_add');
            $api->post('destroy', 'TraceController@destroy');
            $api->post('set_true', 'TraceController@setTrue');
            $api->post('set_many_true', 'TraceController@setManyTrue');
            $api->post('set_all_true', 'TraceController@setAllTrue');
            $api->get('get_trace_export_url', 'TraceController@getTraceExportUrl');
            $api->get('GetExceptionSendGoodLog', 'TraceController@GetExceptionSendGoodLog');
            $api->post('BatchProductionCode', 'TraceController@BatchProductionCode');
            $api->get('exportFastExcel', 'TraceController@exportFastExcel');
            $api->get('getDownloadLog', 'TraceController@getDownloadLog');
            $api->post('downloadFileLog', 'TraceController@downloadFileLog');
            $api->get('GetSendGoodLog', 'TraceController@GetSendGoodLog');//获取发货日志
            $api->get('ExportSendGoodLog', 'TraceController@ExportSendGoodLog');//导出发货日志
        });

        /* 扫码枪 */
        $api->group(['prefix' => 'Account'], function ($api) {
            $api->get('GetSMAccount', 'DeviceAccountController@GetSMAccount');
            $api->post('AddUser', 'DeviceAccountController@AddUser');
            $api->get('UpdateDeviceAccount', 'DeviceAccountController@UpdateDeviceAccount');
        });

        /* 检测报告 */
        $api->group(['prefix' => 'Report'], function ($api) {
            $api->post('AddUpdateReport', 'ReportController@AddUpdateReport');
            $api->get('GetReport', 'ReportController@GetReport');
            $api->get('GetCover', 'ReportController@GetCover');
            $api->get('GetReportList', 'ReportController@GetReportList');
            $api->get('uploadImage', 'ReportController@uploadImage');
        });

        /* 公告 */
        $api->group(['prefix' => 'notice'], function ($api) {
            $api->get('GetNotice', 'NoticeController@WeChatNotice');
            $api->get('GetNoticeList', 'NoticeController@GetNoticeList');
            $api->get('DelNotice', 'NoticeController@DelNotice');
            $api->post('UpdateWeChatNotice', 'NoticeController@UpdateWeChatNotice');
            $api->get('uploadgoodsimage', 'NoticeController@uploadGoodsImage');
        });
    });
});
