<?php

namespace Modules\Order\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use App\Http\Controllers\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;

    public function success($data,$msg="成功"){
        $this->parseNull($data);
        $result = [
            "code"=>200,
            "message"=>$msg,
            "data"=>$data,
        ];
        return response()->json($result,200);
    }

    public function success_list($data,$msg="成功" ,$total=0,$datas=[]){
        $this->parseNull($data);
        $result = [
            "code"=>200,
            "message"=>$msg,
            "data"=>[
                'total'=>$total,
                'list'=>$data
            ],
            'datas'=>$datas
        ];
        return response()->json($result,200);
    }

    //失败返回
    public function error($code=422,$msg="失败",$data=""){
        $result = [
            "code"=>$code,
            "message"=>$msg,
            "data"=>$data
        ];
        return response()->json($result,200);
    }

    //如果返回的数据中有 null 则那其值修改为空 （安卓和IOS 对null型的数据不友好，会报错）
    private function parseNull(&$data){
        if(is_array($data)){
            foreach($data as &$v){
                $this->parseNull($v);
            }
        }else{
            if(is_null($data)){
//                $data = [];
                if(is_array($data)){
                    $data = [];
                }else{
                    $data = '';
                }
            }
        }
    }

    public function get_number($str){
        $result='';
        for($i=0;$i<strlen($str);$i++){
            if(is_numeric($str[$i])){
                $result.=$str[$i];
            }
        }
        return $result;
    }
}
