<?php

namespace Modules\Order\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Support\Facades\Log;

class SendOrderMoneyMessageJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    protected $data;
    public function __construct($data)
    {
        $this->data=$data;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $data=$this->data;
        $user=$data['user'];
        $activity=$data['activity'];
        foreach ($user as $ke=>$va){
            if($va->get_user->openid){
                if ($va->wait_back_accounts==0){
                    $remark='点击链接进入系统，查看详情';
                }else{
                    $remark='其中包含需要退款的金额共'.$va->wait_back_accounts.'元。点击链接进入系统，查看详情';
                }
                $mes['openid']=$va->get_user->openid;
                if (isset($mes['openid'])){
                    $mes['data']=[
                        'first' => '您在'.$activity->title.'中的订单支付情况如下：',
                        'keyword1' => number_format($va->accounts,2),
                        'keyword2' => number_format($va->pay_accounts,2),
                        'keyword3' => number_format($va->no_pay_accounts,2),
                        'keyword4' => date("Y-m-d H:i"),
                        'remark' => $remark,
                    ];
                    event(new \App\Events\NoPayInfo($mes));
                }

//                Log::error($mes);
            }
        }
    }
}
