<?php

namespace Modules\Order\Listeners;

use Modules\Order\Events\NoPayInfo;
use EasyWeChat\Factory;
use Illuminate\Support\Facades\Log;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;

class NoPayInfoListener
{

    protected $template_id;
    protected $url;
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
//        $this->template_id='Yfsn6tuYhD-7QcZ53e7E2UuYb4iytNQEkaxmqc_CvQQ';//测试1
        $this->template_id='FgZJgH06B14FqD1DtiKiUYDQTTgMfOCsL05qWUXkU74';
        $this->url='http://api.app.jiuweiyun.cn/api/gzh';
//        $this->url='http://api.woaidakele.cn/api/gzh';  //测试
    }

    /**
     * Handle the event.
     *
     * @param  NoPayInfo  $event
     * @return void
     */
    public function handle(NoPayInfo $event)
    {
        try{
            $data=$event->data;
            $openid=$data['openid'];
            $config=config('wechat.official_account.default');
            $app = Factory::officialAccount($config);
            $app->template_message->send([
                'touser' => $openid,
                'template_id' => $this->template_id,
                'url' => $this->url,
                'data' => $data['data']
            ]);
        }catch (\Exception $exception){
            Log::error('发送模板消息出错，出错内容为'.$exception);
        }
    }
}
