<?php

namespace Modules\Order\Listeners;

use App\Events\CustomerSendSmsEvent;
use Modules\Order\Events\SoapSendSmsEvent;
use App\Models\ApplyUser;
use Illuminate\Support\Facades\Log;
use Overtrue\EasySms\EasySms;

class SoapSendSmsListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  object  $event
     * @return void
     */
    public function handle(SoapSendSmsEvent $event)
    {
        $d=0;
//        if ($d){
        try {
            $data=$event->data;

            Log::error($data);
            $content='【大卫博士】'."您的订单已经通过{$data['express_com']}发货，快递单号为：{$data['express_num']}，请注意查收。";

            try{
                $easySms=new EasySms(config('easysms'));
                $easySms->send($data['mobile'], [
                    'content' =>$content
                ]);
            }catch (\Exception $exception){
                \Log::error($exception->getMessage());
            }

        }catch (\Exception $exception){
            \Log::error($exception->getMessage());
        }
    }
}
