<?php

namespace Modules\Order\Listeners;

use Modules\Order\Events\SubmitOrderInfo;
use EasyWeChat\Factory;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Support\Facades\Log;

class SubmitOrderInfoListener
{
    protected $template_id;
    protected $url;
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
//        $this->template_id='j3cyptQEnDJ0jbpFgMh643W74zVh2UQGPtGhHBcjaWw';
        $this->template_id='uz8C9bQzu4xb6pcpU0aU5Rl2AjeVR0omnLGgKia5xCE';
        $this->url='http://api.app.jiuweiyun.cn/api/gzh';
//        $this->template_id='j3cyptQEnDJ0jbpFgMh643W74zVh2UQGPtGhHBcjaWw';
//        $this->url='http://api.woaidakele.cn/api/gzh';
    }

    public function handle(SubmitOrderInfo $event)
    {
        try{
            $data=$event->data;
            $openid=$data['openid'];
            $config=config('wechat.official_account.default');
            $app = Factory::officialAccount($config);
            $app->template_message->send([
                'touser' => $openid,
                'template_id' => $this->template_id,
                'url' => $this->url,
                'data' => $data['data']
            ]);
        }catch (\Exception $exception){
            Log::error('发送模板消息出错，出错内容为'.$exception);
        }
    }
}
