<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

$api = app('Dingo\Api\Routing\Router');
$api->version('v1', function ($api) {
    /* 订单路由 */
    $api->group(['namespace'=>'Modules\Order\Http\Controllers'],function ($api) {
        $api->group(['prefix'=>'orders'],function ($api){
            $api->get('getorderlist', 'OrdertestController@order_list');
//            $api->get('getactivityinfo', 'OrdertestController@getActivityInfo');
            $api->get('getgoodsinfo', 'OrdertestController@getGoodsInfo');
            $api->post('UpdateExpress', 'OrdertestController@UpdateExpress');
            $api->post('UploadOrderGift','OrdertestController@UploadOrderGift');
            $api->get('chaidan','OrdertestController@chaidan');
            $api->get('chaidans','OrdertestController@chaidans');
            $api->get('get_info','OrdertestController@orderBreakUpCourier');
            $api->get('order_list_down','OrdertestController@order_list_down');
            $api->post('UploadOrderGifts','OrdertestController@UploadOrderGifts');
            $api->post('GetDelExpressInfo','OrdertestController@GetDelExpressInfo');
            $api->post('DelExpressInfo','OrdertestController@DelExpressInfo');
            $api->get('orderStoreBreakUpCourier','OrdertestController@orderStoreBreakUpCourier');
            $api->get('order_store_list_down','OrdertestController@order_store_list_down');
            $api->get('get_merger_order','OrdertestController@getMergerOrder');
            $api->get('export_merger_order','OrdertestController@exportMergerOrder');
            $api->get('GetApplyOrder','OrdertestController@GetApplyOrder');

            $api->post('destroy_order_address','OrdertestController@destroyOrderAddress');
            $api->post('merge_order', 'OrdertestController@mergeOrder');
            $api->get('merge_order_detail', 'OrdertestController@mergeOrderDetail');
            $api->get('look_good', 'OrdertestController@look_good');
            $api->get('good_detail', 'OrdertestController@good_detail');
            $api->get('order_pass','OrdertestController@order_pass');
            $api->get('order_reject','OrdertestController@order_reject');
            $api->post('send_order','OrdertestController@send_order');
            $api->post('send_express','OrdertestController@send_express');
            $api->get('update_address','OrdertestController@update_address');
            $api->post('audit_order','OrdertestController@audit_order');
            $api->post('many_audit_order','OrdertestController@many_audit_order');
            $api->get('get_user_money','OrdertestController@getUserMoney');
            $api->post('add_income_log','OrdertestController@addIncomeLog');
            $api->post('part_back_money','OrdertestController@partBackMoney');
            $api->get('get_many_back_money_user','OrdertestController@getManyBackMoneyUser');
            $api->post('many_back_money','OrdertestController@manyBackMoney');
            $api->get('get_agent_gift_bag','OrdertestController@getBAgentGiftBag');
            $api->get('get_agent_gift_bag_d','OrdertestController@getBAgentGiftBag_d');
            $api->get('get_honor_wall','OrdertestController@getHonorWall');
            $api->get('get_travel','OrdertestController@getTravel');
            $api->post('add_list_tag','OrdertestController@addListTag');
            $api->post('BatchAddTag','OrdertestController@BatchAddTag');
            $api->get('export_list','OrdertestController@exportList');
            $api->get('export_list_d','OrdertestController@exportList_d');
            $api->get('get_like_agent_gift_bag','OrdertestController@getLikeBAgentGiftBag');
            $api->get('GetBelongOrderRank','OrdertestController@GetBelongOrderRanks');
            $api->get('export_like_agent_gift_bag','OrdertestController@exportLikeBAgentGiftBag');
            $api->get('ExportBelongOrderRank','OrdertestController@ExportBelongOrderRank');
            $api->get('auto_payment','OrdertestController@autoPayment');
            $api->get('get_no_pass_list','OrdertestController@getNoPassList');
            $api->get('get_no_pass','OrdertestController@get_no_pass_list');
            $api->post('sure_order_info','OrdertestController@sureOrderInfo');
            $api->post('no_sure_order_info','OrdertestController@noSureOrderInfo');
            $api->get('import_express_no','OrdertestController@importExpressNo');
            $api->get('add_store','OrdertestController@add_store');//添加订单体验店所属
            $api->post('cancel_store','OrdertestController@cancel_store');//取消订单体验店所属
            $api->get('get_storename','OrdertestController@get_storename');//获取体验店名称
            $api->get('order_store','OrdertestController@order_store');//查看体验店订单
            $api->get('order_store_excel','OrdertestController@order_store_excel');//导出体验店订单
            $api->get('get_collect_money_log','OrdertestController@getCollectMoneyLog');
            $api->get('get_conditions_order_list', 'OrdertestController@getConditionsOrderList');
            $api->get('IsCar', 'OrdertestController@IsCar');
            /**修改订单所属者**/
            $api->get('UpdateBelongId', 'OrdertestController@UpdateBelongId');
            /*获取下面的人**/
            $api->get('GetUser', 'OrdertestController@GetUser');
            $api->get('GetUserId', 'OrdertestController@GetUserId');
            /**修改地址绑定的所属者**/
            $api->get('UpAddress', 'OrdertestController@UpAddress');
            $api->get('order_detail','OrdertestController@order_detail');
            $api->post('submit_order','OrdertestController@submit_order');
            $api->get('show_address','OrdertestController@show_address');
            $api->get('order_address','OrdertestController@order_address');
            $api->get('add_address','OrdertestController@add_address');
            $api->get('add_order_log','OrdertestController@add_order_log');
            $api->get('add_order_detail_log','OrdertestController@add_order_detail_log');
            $api->get('destory_order','OrdertestController@destory_order');
            $api->post('destory_order_all','OrdertestController@destory_order_all');
            $api->post('order_update','OrdertestController@order_update');
            $api->post('down_load','OrdertestController@down_load');
            $api->get('get_crown','OrdertestController@get_crown');
            $api->get('add_store','OrdertestController@add_store');//添加订单体验店所属
            $api->get('get_storename','OrdertestController@get_storename');//获取体验店名称
            $api->get('order_store','OrdertestController@order_store');//查看体验店订单
            $api->get('order_store_excel','OrdertestController@order_store_excel');//导出体验店订单
            $api->get('get_t_data','DataController@get_t_data');//T恤兑换信息
            $api->get('get_t_excel','DataController@get_t_excel');//导出T恤兑换信息
            $api->post('update_t','DataController@update_t');//修改T恤兑换信息
            $api->post('add_t','DataController@add_t');//增加T恤兑换信息
            $api->post('delete_t','DataController@delete_t');//删除兑换信息
            $api->get('get_like_agent_gift_bag','OrdertestController@getLikeBAgentGiftBag');
            $api->get('export_like_agent_gift_bag','OrdertestController@exportLikeBAgentGiftBag');
            $api->post('destroy_order_address','OrdertestController@destroyOrderAddress');
            $api->post('merge_order', 'OrdertestController@mergeOrder');
            $api->get('merge_order_detail', 'OrdertestController@mergeOrderDetail');
            $api->get('get_no_pay_orders', 'OrdertestController@getNoPayOrders');
            $api->get('send_no_pay_info', 'OrdertestController@sendNoPayInfo');
            $api->post('open_auto_pay', 'OrdertestController@openAutoPay');
            $api->get('get_auto_pay_status', 'OrdertestController@getAutoPayStatus');
            $api->post('add_cancel_why', 'OrdertestController@addCancelWhy');
            $api->get('get_cancel_why', 'OrdertestController@getCancelWhy');
            $api->get('/GetExceptionOrder', 'OrdertestController@GetExceptionOrders');
            $api->get('/ExportExceptionOrder', 'OrdertestController@ExportExceptionOrders');
            $api->get('/GetApplyCount', 'OrdertestController@GetApplyCount');

            $api->get('GetOrderDetail', 'OrdertestController@GetOrderDetail');
        });

        /* 肥皂路由 */
        $api->group(['prefix'=>'soap'],function ($api){
            $api->get('GetSoapList','SoapController@GetSoapList');
            $api->get('ExportSoapInfo','SoapController@ExportSoapInfo');
            $api->get('UpdateInfo','SoapController@UpdateInfo');
            $api->post('UploadExpress','SoapController@UploadExpress');
            $api->post('UpdateSoapExpressInfo','SoapController@UpdateSoapExpressInfo');

            $api->get('GetExpressInfo','SoapController@GetExpressInfo');
            $api->get('ExpressSearch','SoapController@ExpressSearch');
            $api->get('UpdateStatus','SoapController@UpdateStatus');
            $api->get('GetTabNum','SoapController@GetTabNum');
            $api->get('UpdateAllStatus','SoapController@UpdateAllStatus');
            $api->get('/Refund','SoapController@Refund');
            /**上传单个物流信息**/
            $api->post('/Express','SoapController@Express');
        });
    });
});
