<?php

namespace Modules\Service\Http\Controllers;

use Modules\Service\Events\SendApplyResultSmsEvent;
use App\Models\ApplyUser;
use App\Models\User;
use App\Models\Warea;
use Carbon\Carbon;
use GuzzleHttp\Client;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ApplyUserController extends Controller
{

    public function GetApplyList(Request $request){
        $page_index=$request->input('page_index',1);
        $page_size=$request->input('page_size',15);
        $search_name=$request->input('search_name','');
        $type=$request->input('type',null);
        $status=$request->input('status',null);
        $audit_status=$request->input('audit_status')??null;

        $start_time=$request->input('start_time',null);
        $end_time=$request->input('end_time',null);
        $data=ApplyUser::query();
        $auth_id=Auth::user()->role_id;


        if ($auth_id==23){
            $id=Warea::where('admin_id',Auth::user()->id)->value('id');
            $ids=User::whereNull('deleted_at')->where('freeze_status',0)->where('warea_id',$id)->pluck('id');
            $data->whereIn('user_id',$ids);
        }
//        elseif($auth_id==22){
//            $data->where('status',1)->where('audit_status',0);
//        }
        if ($search_name){
            $idss=User::where('nickname',"like","%$search_name%")->orwhere('remark_name','like',"%$search_name%")
                ->orwhere('mobile','like',"%$search_name%")->pluck('id');
            $data->whereIn('apply_user_id',$idss);
        }
        if (is_numeric($type)){
            $data->where('type',$type);
        }

        if ($start_time){
            $data->whereBetween('created_at',[$start_time,$end_time]);
        }

        if (is_numeric($audit_status)){
            $data->where('audit_status',$audit_status);
        }

        if ($status==3){
            $data->where('apply_status',1);
        }else{
            if (is_numeric($status)){
                $data->where('status',$status)->where('apply_status',0);
            }
        }
        $count=$data->count();
        $list=$data->with(['GetUser','GetApplyUser'=>function($q){
            $q->with(['warea']);
        }])->orderByDesc('id')->take($page_size)->skip(($page_index-1)*$page_size)->get();
        return $this->success_list($list,'',$count);
    }

    /**政委审核--**/

    public function UpdateApplyStatus(Request $request){
//        return $this->error(500214,'该功能升级中，请等待通知！');
        $img=$request->input('img',null);
        $re=ApplyUser::find($request->id);
        if ($re){
            $re->status=$request->status;
            $re->audit_status=0;
            if ($request->status==2){
                $re->op_time=Carbon::now()->toDateTimeString();

                $re->remark=$request->remark;
                $re->reject_imgList=$img;
            }else{
                if ($re->type==1){
                    $re->audit_status=1;
                    $re->status=1;
                    try{
                        $data=[
                            'id'=>$re->id
                        ];
                        event(new SendApplyResultSmsEvent($data));
                    }catch (\Exception $exception){
                        \Log::error($exception->getMessage());
                    }
                }
            }
            $re->save();

        }
        return $this->success([]);
    }

    /**公司审核**/
    public function UpdateApplyAuditStatus(Request $request){
        $re=ApplyUser::find($request->id);
        $re->audit_time=Carbon::now()->toDateTimeString();
        $re->audit_status=$request->audit_status;
        if ($request->audit_status==2){
            $re->status=0;
        }
        $re->audit_remark=$request->audit_remark;
        $re->save();
        if($re->audit_status==1){
            try{
                $data=[
                    'id'=>$re->id
                ];
                event(new SendApplyResultSmsEvent($data));
            }catch (\Exception $exception){
                \Log::error($exception->getMessage());
            }
        }
        return $this->success([]);
    }



    public function UpdateApplyStatuss(Request $request){
        return $this->error(500214,'该功能暂停使用');
        $img=$request->input('img',null);
        $re=ApplyUser::find($request->id);
        if ($re){
            $re->op_time=Carbon::now()->toDateTimeString();
            $re->status=$request->status;
            $re->remark=$request->remark;
            $re->reject_imgList=$img;
            $re->save();
            try{
                $data=[
                    'id'=>$re->id
                ];
                event(new SendApplyResultSmsEvent($data));
            }catch (\Exception $exception){
                \Log::error($exception->getMessage());
            }
        }
        return $this->success([]);
    }

    public function UpdateApplyAllStatus(Request $request){
        $img=$request->input('img',null);
        $ids=$request->input('id');
        $re=ApplyUser::find($request->id);
        if ($re){
            $re->op_time=Carbon::now()->toDateTimeString();
            $re->status=$request->status;
            $re->remark=$request->remark;
            $re->reject_imgList=$img;
            $re->save();
            try{
                $data=[
                    'id'=>$re->id
                ];
                event(new SendApplyResultSmsEvent($data));
            }catch (\Exception $exception){
                \Log::error($exception->getMessage());
            }
        }
        return $this->success([]);
    }

    public function uploadImage(Request $request){
        $apply=ApplyUser::where('id',$request->input('id',null))->first();
        if(empty($apply)){
            return $this->error('450001','修改申请不存在');
        }
        $client = new Client();
        $url = 'http://api.app.jiuweiyun.cn/api/user_apply/upload_apply_image';
        $array = [
            'multipart' => [
                [
                    'name'=>'id',
                    'contents'=>$apply->user_id
                ],
                [
                    'name' => 'img',
                    'contents' => fopen($request->file('img')->getRealPath(),'r'),
                ]
            ]
        ];
        $response = $client->request('POST', $url, $array);
        $result = json_decode($response->getBody()->getContents(),true);
        if($result['code']==200){
            return $this->success($result['imgUrl']);
        }
        return $this->error();
    }

    public function editApplyInfo(Request $request){
        $id=$request->input('id',null);
        $amount_img=$request->input('amount_img',null);
        $sale_data=$request->input('sale_data',null);
        $apply=ApplyUser::where('id',$id)->first();
        if(empty($apply)){
            return $this->error('450001','修改申请不存在');
        }
        $data['old_amount_img']=json_decode($apply->data,true);
        $data['old_sale_data']=json_decode($apply->goods_data,true);
        $log=Auth::user()->name.'('.Auth::user()->id.')于'.date("Y-m-d H:i:s").'修改了申请信息，修改前信息记录如下:'.PHP_EOL.json_encode($data);
        $apply->data=$amount_img?json_encode($amount_img):null;
        $apply->goods_data=$sale_data?json_encode($sale_data):null;
        $apply->log=$log;
        $res=$apply->save();
        if($res){
            return $this->success([]);
        }else{
            return $this->error();
        }
    }

    public function Get(){
        $app=ApplyUser::where('id',69)->with(['GetApplyUser'])->with(['GetUser'])->first()->toArray();
        dd($app);
    }

    public function ExportExcel(Request $request){
        $search_name=$request->input('search_name','');
        $type=$request->input('type',null);
        $status=$request->input('status',null);
        $audit_status=$request->input('audit_status')??null;

        $start_time=$request->input('start_time',null);
        $end_time=$request->input('end_time',null);
        $data=ApplyUser::query();
        $auth_id=Auth::user()->role_id;



        if ($auth_id==23){
            $id=Warea::where('admin_id',Auth::user()->id)->value('id');
            $ids=User::whereNull('deleted_at')->where('freeze_status',0)->where('warea_id',$id)->pluck('id');
            $data->whereIn('user_id',$ids);
        }
        if ($search_name){
            $idss=User::where('nickname',"like","%$search_name%")->orwhere('remark_name','like',"%$search_name%")
                ->orwhere('mobile','like',"%$search_name%")->pluck('id');
            $data->whereIn('apply_user_id',$idss);
        }
        if (is_numeric($type)){
            $data->where('type',$type);
        }

        if ($start_time){
            $data->whereBetween('created_at',[$start_time,$end_time]);
        }

        if ($audit_status){
            $data->where('audit_status',$audit_status);
        }

        if ($status==3){
            $data->where('apply_status',1);
        }else{
            if (is_numeric($status)){
                $data->where('status',$status)->where('apply_status',0);
            }
        }
        $list=$data->with(['GetUser','GetApplyUser'=>function($q){
            $q->with(['warea','crown']);
        }])->orderByDesc('id')->get();

        $data=[];
        foreach ($list as $k=>$v){
            if($v->GetApplyUser){
                $data[$k]['手机号']=$v->GetApplyUser->mobile;
                $data[$k]['昵称']=$v->GetApplyUser->nickname;
                $data[$k]['真实姓名']=$v->GetApplyUser->realname;
                $data[$k]['级别']=$this->judge_level($v->GetApplyUser->level);
                $data[$k]['战区']=$v->GetApplyUser->warea?$v->GetApplyUser->warea->name:null;
                $data[$k]['团队老大']=$v->GetApplyUser->crown?$v->GetApplyUser->crown->nickname:null;
            }else{
                $data[$k]['手机号']='无';
                $data[$k]['昵称']='无';
                $data[$k]['真实姓名']='无';
                $data[$k]['级别']='未知';
                $data[$k]['战区']='未知';
                $data[$k]['团队老大']='未知';
            }

            $data[$k]['类型']=$this->judge_type($v->type);
            $data[$k]['变动时间']='';
            if ($v->status==0 && $v->audit_status==0){
                $status='未审核';
            }elseif ($v->status==1 && $v->audit_status==0){
                $status='公司未审核';
            }elseif ($v->status==2){
                $status='驳回';
            }elseif ($v->status==1 && $v->audit_status==1){
                $status='已完成';
                $data[$k]['变动时间']=$v->audit_time??$v->op_time;
            }
            $data[$k]['状态']=$status;
            $data[$k]['审核时间']=$v->op_time;
        }
        return $this->success($data);
    }

    function judge_type($type){
        switch ($type){
            case 0:
                $type='降级';
                break;
            case 1:
                $type='升级';
                break;
            case 2:
                $type='删除';
                break;
        }
        return $type;
    }

    function judge_level($level){
        switch ($level){
            case 1:
                $level='销售主管';
                break;
            case 2:
                $level='销售经理';
                break;
            case 3:
                $level='代理公司';
                break;
        }
        return $level;
    }

}
