<?php

namespace Modules\Service\Jobs;

use App\Models\DHActivityInfo;
use App\Models\DHApply;
use App\Models\DHGoodInfo;
use App\Models\DHGoodTime;
use App\Models\DHMoney;
use App\Models\DHMoneyPct;
use App\Models\Ordertest;
use Illuminate\Bus\Queueable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Support\Facades\Log;

class ReckonDHMoneyInfoJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */

    protected $data;
    public function __construct($data)
    {
        $this->data=$data;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $data=$this->data;

        $info=DHGoodInfo::find($data['id']);
        $good_info=json_decode($info->depot_record_info);
        $dh_money=0;
        try {
            $all_money=0;
            foreach ($good_info as $k=>$v){
                foreach ($v->list as $kes=>$vas){
                    $res=DHActivityInfo::where('time_end','>',$vas->time)->where('time_start','<=',$vas->time)->first();
                    if (!$res){
                        $res=DHActivityInfo::orderByDesc('time_end')->limit('1')->first();
                    }
                    if ($vas->time<'2020-05-01'){

                        $price=DHGoodTime::where('good_name',$v->good_name)
                            ->where('time_start','<=',$vas->time)->where('time_end','>',$vas->time)->value('price');

                    }else{
                        $time_start=$res->time_start;
                        $price=DHGoodTime::where('good_name',$v->good_name)
                            ->where('time_start','<=',$time_start)->where('time_end','>',$time_start)->value('price');
                    }

                    if ($res->time_start!='2014-01-01 00:00:00'){
                        $money=Ordertest::whereBetween('created_at',[$res->time_start,$res->time_end])->where('user_id',$info->crown_id)->where('is_deleted',0)->sum('money');
                        $re=DHMoneyPct::where('money_start','<',$money)->where('money_end','>',$money)->orderBy('id')->get();
                        $n=0;
                        /*根据规则计算当前金额应该返现的比例
                         * **/
                        foreach ($re as $ke=>$va){
                            if ($va->time_start<$res->time_start && $res->time<$va->time_end){
                                $n=$va->pct;
                            }
                        }
                        $all_money+=$n*$vas->num*$price;
                    }
                    $money_info=new DHMoney();
                    $money_info->dh_id=$info->dh_id;
                    $money_info->money=$price;
                    $money_info->is_recoup=0;
                    $money_info->type=0;
                    $money_info->good_name=$v->good_name;
                    $money_info->good_size=$vas->size;
                    $money_info->good_sex=$vas->sex;
                    $money_info->remark=$vas->time.$v->good_name.'的商品金额';
                    $money_info->good_num=$vas->num;
                    $money_info->good_time=$vas->time;
                    $money_info->save();
                    $dh_money+=$price*$vas->num;
                }
            }

            if ($info->lack_tote){
                $money_info=new DHMoney();
                $money_info->dh_id=$info->dh_id;
                $money_info->money=2;
                $money_info->is_recoup=1;
                $money_info->type=1;
                $money_info->good_name='手提袋';
                $money_info->remark='手提袋金额';
                $money_info->good_num=$info->lack_tote;
                $money_info->save();
                $dh_money=$dh_money-$info->lack_tote*2;
            }

            if ($info->lack_soap){
                $money_info=new DHMoney();
                $money_info->dh_id=$info->dh_id;
                $money_info->money=8;
                $money_info->is_recoup=1;
                $money_info->type=2;
                $money_info->good_name='肥皂';
                $money_info->remark='肥皂金额';
                $money_info->good_num=$info->lack_soap;
                $money_info->save();
                $dh_money=$dh_money-$info->lack_soap*8;
            }

            $wear_info=json_decode($info->wear_info,true);
            $nowear_info=json_decode($info->nowear_info,true);
            $wear=[];
            foreach ($wear_info as $k=>$v){
                $wear[$k]=$v+$nowear_info[$k];
            }

            foreach ($wear as $k=>$v){
                if ($k=='hard'){
                    $good_name='精装版';
                }elseif ($k=='simple'){
                    $good_name='简约版';
                }elseif ($k=='old'){
                    $good_name='高腰版';
                }elseif ($k=='old_new'){
                    $good_name='纯棉版';
                }else{
                    $good_name='青春版';
                }
                if ($v>0){
                    $good_price=DHGoodTime::where('good_name',$good_name)->orderByDesc('time_end')->limit(1)->value('price');
                    $good_price=bcdiv($good_price,3,1);
                    $money_info=new DHMoney();
                    $money_info->dh_id=$info->dh_id;
                    $money_info->money=$good_price;
                    $money_info->is_recoup=0;
                    $money_info->type=4;
                    $money_info->good_name=$good_name;
                    $money_info->remark='单条'.$good_name.'的总金额，包含已穿未穿';
                    $money_info->good_num=$v;
                    $money_info->save();
                    $dh_money+=$v*$good_price;
                    $res=DHActivityInfo::orderByDesc('time_end')->limit('1')->first();
                    $money=Ordertest::whereBetween('created_at',[$res->time_start,$res->time_end])->where('user_id',$info->crown_id)->where('is_deleted',0)->sum('money');
                    $re=DHMoneyPct::where('money_start','<',$money)->where('money_end','>',$money)->orderBy('id')->get();
                    $n=0;
                    /*根据规则计算当前金额应该返现的比例
                     * **/
                    foreach ($re as $ke=>$va){
                        if ($va->time_start<$res->time_start && $res->time<$va->time_end){
                            $n=$va->pct;
                        }
                    }
                    $all_money+=$n*$good_price*$v;
                }

            }

            if ($all_money>0){
                $money_info=new DHMoney();
                $money_info->dh_id=$info->dh_id;
                $money_info->money=$all_money;
                $money_info->is_recoup=1;
                $money_info->type=3;
                $money_info->good_name='扣除奖励的部分金额';
                $money_info->remark='奖励金扣除';
                $money_info->good_num=1;
                $money_info->save();
            }
            $dh_money=$dh_money-$all_money;
            DHApply::where('id',$info['dh_id'])->update(['status'=>6,'dh_money'=>$dh_money]);
        }catch (\Exception $exception){
            DHApply::where('id',$info->dh_id)->update(['is_exception'=>1]);
        }
    }
}
