<?php

namespace Modules\Service\Listeners;

use Modules\Service\Events\AddAgent;
use App\Models\User;
use App\Models\UserZ;
use App\Models\Warea;
use App\Models\WarZone;
use App\Models\Service;
use Illuminate\Support\Facades\Log;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;

class AddAgentListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  AddAgent  $event
     * @return void
     */
    public function handle(AddAgent $event)
    {
        $user=$event->user;
        $warea=Warea::where('id',$user->warea_id)->first();
        $war_name= explode('战区',$warea->name)[0];
        if($user->level==1){
            $level_name='销售主管';
            $uup=User::where('id',$user->agent_id)->first();
            if($uup->level==3){
                $up=$uup;
            }
            if($uup->level==2){
                $up=User::where('id',$uup->agent_id)->first();
            }
        }
        if($user->level==2){
            $level_name='销售经理';
            $up=User::where('id',$user->agent_id)->first();
        }
        if($user->level==3){
            $level_name='代理公司';
            $war=WarZone::where('war_name',$war_name)->first();
            $up=UserZ::where('id',$war->uid)->select('id','nickname','phone as mobile')->first();
            Service::create([
                'phone'=>$user->mobile,
                'uid'=>$war->uid,
                'war_names'=>$war_name,
            ]);
        }

        UserZ::create([
            'openid'=>$user->mobile,
            'phone'=>$user->mobile,
            'nickname'=>$user->nickname,
            'name'=>$user->realname??$user->nickname,
            'up_phone'=>$up->mobile,
            'up_name'=>$up->nickname,
            'level_name'=>$level_name,
            'war_names'=>$war_name,
            'status'=>0,
        ]);
    }
}
