<?php

namespace Modules\Service\Listeners;

use Modules\Service\Events\AgentAuditServiceEvent;
use App\Models\User;
use App\Models\Warea;
use Illuminate\Queue\Listener;
use Illuminate\Support\Facades\Log;

class AgentAuditServiceListener {
    protected $template_id;
    protected $url;

    //认证审核通知  通知上级 和 邀请人  审核结果

    public function __construct()
    {
        $this->template_id='6fKG5UML7jpoQ6p43vV3InYiwH2rLWNVMwSsfSNio3U';
        $this->url='http://api.app.jiuweiyun.cn/api/gzh';
    }

    /**
     * Handle the event.
     *
     * @param  AgentAuditServiceListener  $event
     * @return void
     */
    public function handle(AgentAuditServiceEvent $event)
    {
        try{
            $data=$event->data;
            $openid=$data['openid'];
            $app=app('wechat.official_account');

            $app->template_message->send([
                'touser' => $openid,
                'template_id' => $this->template_id,
                'url' => $this->url,
                'data' => $data['data']
            ]);


        }catch (\Exception $exception){
            Log::error('发送模板消息出错，出错内容为'.$exception);
        }
    }

}
