<?php

namespace Modules\Service\Listeners;

use Modules\Service\Events\ChangeUserWar;
use App\Models\UserZ;
use App\Models\Warea;
use App\Models\WarZone;
use App\Models\Service;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;

class ChangeUserWarListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  ChangeUserWar  $event
     * @return void
     */
    public function handle(ChangeUserWar $event)
    {
        $user=$event->user;
        $before_warea=Warea::where('id',$user->before)->value('name');
        $warea=Warea::where('id',$user->warea_id)->first();//战区信息
        $war_name= explode('战区',$warea->name)[0];
        $uid=WarZone::where('war_name',$war_name)->value('uid');//政委id
        $uu=UserZ::where('id',$uid)->first();//争霸赛政委信息
        Service::where('phone',$user->mobile)->update(['war_names'=>$war_name,'uid'=>$uid]);
        UserZ::where('phone',$user->mobile)->where('level_name','!=','政委')->update(['war_names'=>$war_name,'up_phone'=>$uu->phone,'up_name'=>$uu->nickname]);
        UserZ::where('up_phone',$user->mobile)->where('level_name','!=','政委')->update(['war_names'=>$war_name]);
    }
}
