<?php

namespace Modules\Service\Listeners;

use Modules\Service\Events\CustomerSendSmsEvent;
use App\Models\ApplyUser;
use Illuminate\Support\Facades\Log;
use Overtrue\EasySms\EasySms;

class CustomerSendSmsListener
{
    /**
     * Create the event listener.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Handle the event.
     *
     * @param  object  $event
     * @return void
     */
    public function handle(CustomerSendSmsEvent $event)
    {
        $d=0;
//        if ($d){
        try {
            $data=$event->data;
            if ($data['status']==0){
                $content='【大卫博士】'."您调换的内裤即将使用 {$data['express_com']} 发出，快递单号为{$data['express_num']}。请注意查收，如有其他疑问，请联系代理。";
            }else{
                $content='【大卫博士】'."原快递信息（{$data['old_express_num']}）已更改为{$data['express_com']}，快递单号为{$data['express_num']}。请注意查收。如有其他疑问，请联系代理。";
            }

            try{
                $easySms=new EasySms(config('easysms'));
                $easySms->send($data['mobile'], [
                    'content' =>$content
                ]);
            }catch (\Exception $exception){
                \Log::error($exception->getMessage());
            }

        }catch (\Exception $exception){

        }
    }
}
