<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

//Route::middleware('auth:api')->get('/service', function (Request $request) {
//    return $request->user();
//});
$api = app("Dingo\Api\Routing\Router");
$api->version('v1', function ($api) {
    /* 客服路由 */
    $api->group(['namespace' => 'Modules\Service\Http\Controllers'], function ($api) {
        /* 客户路由 */
        $api->group(['prefix' => 'user'], function ($api) {
            $api->get('Cancel_status', 'UserController@Cancel_status');
            $api->post('addtestuser', 'UserController@addTestUser');
            $api->post('canceltestuser', 'UserController@cancelTestUser');
            $api->get('exportuserlist', 'UserController@exportUserList');
            $api->get('getnocertuserlist', 'UserController@getNocertUserList');
            $api->post('restoreCompanyRejected', 'UserController@restoreCompanyRejected');//恢复代理公司驳回
            $api->get('getagentgoodsnum', 'UserController@getAgentGoodsNum');
            $api->get('getauthuserlist', 'UserController@getAuthUserList');
            $api->post('updateusermanyauthinfo', 'UserController@updateUserManyAuthInfo');
            $api->post('updateuserauthinfo', 'UserController@updateUserAuthInfo');
            $api->post('updatemobile', 'UserController@updateMobile');
            $api->post('editagentpassword', 'UserController@editAgentPassword');
            $api->post('uploaduser', 'UserController@uploadUser');
            $api->post('destoryuser', 'UserController@destoryUser');
            $api->post('shelveduser', 'UserController@shelvedUser');
            $api->post('updaterecom', 'UserController@updateRecom');
            $api->post('updateagentlevel', 'UserController@updateAgentLevel');
            $api->post('certuserstatus', 'UserController@certUserStatus');
            $api->post('certuserstatus_all', 'UserController@certUserStatus_all');
            $api->post('againcertrecomstatus', 'UserController@againCertRecomStatus');
            $api->post('againcertagentstatus', 'UserController@againCertAgentStatus');
            $api->post('crownselectwarea', 'UserController@crownSelectWarea');
            $api->post('update_user', 'UserController@update_user');
            $api->get('repair_auth', 'UserController@repair_auth');
            $api->post('restoreUserInfo', 'UserController@restoreUserInfo');
            $api->post('destroy_upload_img', 'UserController@destroyUploadImg');
            $api->post('destroy_upload_audio', 'UserController@destroyUploadAudio');
            $api->get('UpdateWarea', 'UserController@UpdateWarea');
            $api->get('GetEnrolls', 'UserController@GetEnrolls');
            $api->get('uploadImage', 'UserController@uploadImage');
            $api->get('Apply', 'UserController@Apply');
            $api->get('RejectAccept', 'UserController@RejectAccept');
            $api->get('GetUserInfos','UserController@GetUserInfos');
            /**
             * 政委审核功能
             *****/
            $api->get('search_peoples', 'UserController@search_peoples');
            $api->get('LookImg', 'UserController@LookImg');
            $api->get('GetWareaCrown', 'UserController@GetWareaCrown');
            $api->get('download_peoples', 'UserController@download_peoples');
            $api->get('UserRemove', 'UserController@UserRemove');
            $api->get('service_audit', 'UserController@service_audit');
            $api->get('get_reason', 'UserController@get_reason');
            $api->get('add_reason', 'UserController@add_reason');
            $api->get('GetCrownInfo', 'UserController@GetCrownInfo');
            $api->get('GetNextInfo', 'UserController@GetNextInfo');
            $api->get('GetLastInfo', 'UserController@GetLastInfo');
            //获取原因（前面全部加个 /user）
            $api->get('get_del_cause', 'UserController@get_del_cause');
            //增加原因
            $api->get('add_del_cause', 'UserController@add_del_cause');
            //删除原因
            $api->get('destory_del_cause', 'UserController@destory_del_cause');
            $api->get('get_jj_cause', 'UserController@get_jj_cause');
            $api->get('add_jj_cause', 'UserController@add_jj_cause');
            $api->get('destory_jj_cause', 'UserController@destory_jj_cause');
            $api->get('SearchUser', 'UserController@SearchUser');
            $api->get('SearchTeamUser', 'UserController@SearchTeamUser');
            /**解绑*/
            $api->get('UnbindWechat', 'UserController@UnbindWechat');
        });

        /* 调货管理 */
        $api->group(['prefix' => 'CustmoerApply'], function ($api) {
            $api->get('GetCrown', 'CustomerChangeController@GetCrown');
            $api->get('GetApplyList', 'CustomerChangeController@GetApplyList');
            $api->post('Apply', 'CustomerChangeController@Apply');
            $api->get('GetProblemCollection', 'CustomerChangeController@GetProblemCollection');
            $api->get('AddProblemCollection', 'CustomerChangeController@AddProblemCollection');
            $api->post('UploadCustomerInfo', 'CustomerChangeController@UploadCustomerInfo');//上传快递单号
            $api->post('UpdateCustomerInfo', 'CustomerChangeController@UpdateCustomerInfo');//修改快递单号
            $api->get('AddStoreHouseStorage', 'CustomerChangeController@AddStoreHouseStorage');
            $api->get('UpdateStoreHouseStorage', 'CustomerChangeController@UpdateStoreHouseStorage');
            $api->get('StoreHouseStorage', 'CustomerChangeController@StoreHouseStorage');
            $api->get('ProblemAnalyse', 'CustomerChangeController@ProblemAnalyse');//问题统计
            $api->get('WareaProblemAnalyse', 'CustomerChangeController@WareaProblemAnalyse');//战区数量统计
            $api->get('CrownProblemAnalyse', 'CustomerChangeController@CrownProblemAnalyse');//代理公司问题数量统计
            $api->get('CrownProblemAnalyseOnlyOne', 'CustomerChangeController@CrownProblemAnalyseOnlyOne');//代理公司问题数量统计
            $api->get('WareaProblemAnalyseOnlyOne', 'CustomerChangeController@WareaProblemAnalyseOnlyOne');//代理公司问题数量统计
            $api->get('ExpressSearch', 'CustomerChangeController@ExpressSearch');//查询物流
            $api->get('ExportApplyList', 'CustomerChangeController@ExportApplyList');//导出申请单
            $api->get('ExportApplyLists', 'CustomerChangeController@ExportApplyLists');//导出申请单
            $api->get('AddLabelCollection', 'CustomerChangeController@AddLabelCollection');//增加状态
            $api->get('GetLabelCollection', 'CustomerChangeController@GetLabelCollection');//导出申请单
            $api->get('GetExceptionList', 'CustomerChangeController@GetExceptionList');//异常记录
            $api->get('AuditApplyList', 'CustomerChangeController@AuditApplyList');//审核
            $api->get('AuditBackApply', 'CustomerChangeController@AuditBackApply');//退回审核
            $api->post('UpdateApply', 'CustomerChangeController@UpdateApply');//修改调换单
            $api->get('CheckNum', 'CustomerChangeController@CheckNum');//校验数量
            $api->post('UpdateApplyInfos', 'CustomerChangeController@UpdateApplyInfos');//校验数量
            $api->get('GetGoodNum', 'CustomerChangeController@GetGoodNum');
            $api->get('TagOwe', 'CustomerChangeController@TagOwe');
            $api->get('DelApplyCustomer', 'CustomerChangeController@DelApplyCustomer');
            $api->get('CancelTagOwe', 'CustomerChangeController@CancelTagOwe');
            $api->get('GetCustomerInfo', 'CustomerChangeController@GetCustomerInfo');
            $api->get('CheckRepeatInfo', 'CustomerChangeController@CheckRepeatInfo');//校验七天内是否有重复的信息
            $api->get('Receipt', 'CustomerChangeController@Receipt');//校验七天内是否有重复的信息
            $api->post('Express', 'CustomerChangeController@Express');//校验七天内是否有重复的信息
            $api->post('SearchUser', 'CustomerChangeController@SearchUser');//校验七天内是否有重复的信息
        });

        /* 退货管理 */
        $api->group(['prefix' => 'CustomerReturn'], function ($api) {
            $api->get('GetApplyList', 'CustomerReturnController@GetApplyList');
            $api->post('Apply', 'CustomerReturnController@Apply');
            $api->post('UpdateApply', 'CustomerReturnController@UpdateApply');
            $api->get('GetCrown', 'CustomerReturnController@GetCrown');
            $api->get('UploadReturnInfo', 'CustomerReturnController@UploadReturnInfo');
            $api->get('UploadReturnExpressInfo', 'CustomerReturnController@UploadReturnExpressInfo');
            $api->get('UploadCrownReturnInfo', 'CustomerReturnController@UploadCrownReturnInfo');
            $api->get('GetHistory', 'CustomerReturnController@GetHistory');
            $api->get('AddProblemCollection', 'CustomerReturnController@AddProblemCollection');
            $api->get('GetProblemCollection', 'CustomerReturnController@GetProblemCollection');
            $api->get('ExportApplyLists', 'CustomerReturnController@ExportApplyLists');
            $api->get('GetLevelAnalysis', 'CustomerReturnController@GetLevelAnalysis');
            $api->get('GetNumPriceAnalysis', 'CustomerReturnController@GetNumPriceAnalysis');
            $api->get('GetCustomerAnalysis', 'CustomerReturnController@GetCustomerAnalysis');
            $api->get('GetStore', 'CustomerReturnController@GetStore');
            $api->get('ExpressSearch', 'CustomerReturnController@ExpressSearch');
            $api->post('UploadImg', 'CustomerReturnController@uploadImg');
            $api->post('uploadStoreImg', 'CustomerReturnController@uploadStoreImg');
        });

        /* 库存管理 */
        $api->group(['prefix' => 'storage'], function ($api) {
            $api->get('GetCrownStorage', 'StorageController@GetCrownStorage');
            $api->get('GetCrownTime', 'StorageController@GetCrownTime');
            $api->get('GetStorageNum', 'StorageController@GetStorageNum');
            $api->get('exportData', 'StorageController@exportData');
            $api->get('GetPutOutDetail', 'StorageController@GetPutOutDetail');
            $api->get('exportData', 'StorageController@exportData');
            $api->get('ExportStorageDetail', 'StorageController@ExportStorageDetail');
            //                $api->post('updateagentstatus', 'AuditController@updateAgentStatus');
            $api->get('StoragePutStatistical', 'StorageController@StoragePutStatistical');
            $api->get('StorageOutStatistical', 'StorageController@StorageOutStatistical');
            $api->get('StorageStatistical', 'StorageController@StorageStatistical');
            $api->get('StorageRemind', 'StorageController@StorageRemind');
            $api->get('GetStorageDetailDate', 'StorageController@GetStorageDetailDate');
            $api->get('GetUserStorageDateDetail', 'StorageController@GetUserStorageDateDetail');
            $api->get('CancelRemind', 'StorageController@CancelRemind');
            $api->get('ExportOutPutRecord', 'StorageController@ExportOutPutRecord');
            $api->get('GetSmsTime', 'StorageController@GetSmsTime');
            $api->get('SetSmsTime', 'StorageController@SetSmsTime');
        });

        /* 礼包图片管理 */
        $api->group(['prefix' => 'UserImg'], function ($api) {
            $api->get('GetUserInfo', 'ActivityImgController@GetUserInfo');
            $api->get('GetUserInfo_b', 'ActivityImgController@GetUserInfo_b');
            $api->get('GetUserInfos', 'ActivityImgController@GetUserInfos');
            $api->get('AddUpdateImg', 'ActivityImgController@AddUpdateImg');
            $api->get('AddUpdateImg_b', 'ActivityImgController@AddUpdateImg_b');
            $api->get('AddUpdateImgB', 'ActivityImgController@AddUpdateImgB');
            $api->get('AddUpdateImgB_d', 'ActivityImgController@AddUpdateImgB_d');
            $api->get('AgainCreateImg', 'ActivityImgController@AgainCreateImg');
            $api->get('AgainCreateImg_b', 'ActivityImgController@AgainCreateImg_b');
            $api->get('AgainCreateImgB', 'ActivityImgController@AgainCreateImgB');
            $api->get('AgainCreateImgB_d', 'ActivityImgController@AgainCreateImgB_d');
            $api->get('GetUserList', 'ActivityImgController@GetUserList');
            $api->get('GetUserList_b', 'ActivityImgController@GetUserList_b');
            $api->get('GetImgStatus', 'ActivityImgController@GetImgStatus');
            $api->get('GetImgStatus_b', 'ActivityImgController@GetImgStatus_b');
            $api->get('GetImgStatusB', 'ActivityImgController@GetImgStatusB');
            $api->get('GetImgStatusB_d', 'ActivityImgController@GetImgStatusB_d');
            $api->post('AddUserImgInfo', 'ActivityImgController@AddUserImgInfo');
            $api->post('AddUserImgInfo_b', 'ActivityImgController@AddUserImgInfo_b');
            $api->post('uploadImage', 'ActivityImgController@uploadImage');
            $api->post('UpdateUserImgInfo', 'ActivityImgController@UpdateUserImgInfo');
            $api->post('UpdateUserImgInfoB', 'ActivityImgController@UpdateUserImgInfoB');
            $api->post('UpdateCrownImgInfo', 'ActivityImgController@UpdateCrownImgInfo');
            $api->get('GetCrownInfo', 'ActivityImgController@GetCrownInfo');
            $api->get('DeleteUserImg', 'ActivityImgController@DeleteUserImg');
            $api->get('ExportAddress', 'ActivityImgController@ExportAddress');
            $api->get('ExportAddress_b', 'ActivityImgController@ExportAddress_b');
        });

        /*活动*/
        $api->group(['prefix' => 'activity'], function ($api) {
            $api->get('getactivitylist', 'ActivityController@getActivityList');
            $api->post('addactivity', 'ActivityController@addActivity');
            $api->post('updateactivity', 'ActivityController@updateActivity');
            $api->post('disabledactivity', 'ActivityController@disabledActivity');
            $api->post('destoryactivity', 'ActivityController@destoryActivity');
            $api->get('get_act_honor_info', 'ActivityController@getActHonorInfo');
            $api->get('get_act_levels_info', 'ActivityController@getActLevelsInfo');
            $api->post('uploadgiftimage', 'ActivityController@uploadGiftImage');
            $api->post('uploadTest', 'ActivityController@uploadTest');
        });

        $api->group(['prefix'=>'WareaApply'], function ($api) {
            $api->get('Apply', 'WareaApplyController@Apply'); //删除客户
            $api->get('GetApplyList', 'WareaApplyController@GetApplyList');
            $api->get('RejectAccept', 'WareaApplyController@RejectAccept');
            $api->get('UpdateApply', 'WareaApplyController@UpdateApply');
            $api->get('GetApplyListCount', 'WareaApplyController@GetApplyListCount');
            $api->get('destroy', 'WareaApplyController@destroy');
            $api->get('GetUserInfo', 'WareaApplyController@GetUserInfo');
        });

        $api->group(['prefix'=>'apply'],function ($qpi){
            $qpi->get('GetApplyList','ApplyUserController@GetApplyList');
            $qpi->get('ExportExcel','ApplyUserController@ExportExcel');
            $qpi->get('UpdateApplyAuditStatus','ApplyUserController@UpdateApplyAuditStatus');
            $qpi->get('UpdateApplyStatus','ApplyUserController@UpdateApplyStatus');
            $qpi->post('uploadImage','ApplyUserController@uploadImage');
            $qpi->post('editApplyInfo','ApplyUserController@editApplyInfo');
        });

        /*退货路由*/
        $api->group(['prefix'=>'ReturnGood'], function ($api){
            $api->get('/GetUser','DHApplyController@GetUser');
            $api->get('/GoodDetail','DHApplyController@GoodDetail');
            $api->get('/GetInfo','DHApplyController@GetInfo');
            $api->post('/CheckIn','DHApplyController@CheckIn');
            $api->post('/EditExpressInfo','DHApplyController@EditExpressInfo');
            $api->post('/UploadMoneyImg','DHApplyController@UploadMoneyImg');
            $api->post('/UserSign','DHApplyController@UserSign');
            $api->get('/SureMoney','DHApplyController@SureMoney');
            $api->post('/CrownMoneySign','DHApplyController@CrownMoneySign');
            $api->post('/UploadImg','DHApplyController@UploadImg');
            $api->post('/CrownLookMoney','DHApplyController@CrownLookMoney');
            $api->post('/CrownLookMoneySign','DHApplyController@CrownLookMoneySign');
            $api->post('/UserConfirmMoneySign','DHApplyController@UserConfirmMoneySign');
            $api->get('/GetApplyList','DHApplyController@GetApplyList');
            $api->get('/GetStatus','DHApplyController@GetStatus');

            $api->get('/GetExpress','DHApplyController@GetExpress');
            $api->get('/GetCodeInfo','DHApplyController@GetCodeInfo');
            $api->get('/ReckonMoney','DHApplyController@ReckonMoney');
            $api->get('/UpdateReturnMoney','DHApplyController@UpdateReturnMoney');
            $api->post('/InsertGoodInfo','DHApplyController@InsertGoodInfo');
            $api->post('/AddReturnMoney','DHApplyController@AddReturnMoney');
            $api->post('/UpdateApplyInfo','DHApplyController@UpdateApplyInfo');
            $api->post('/UploadImage','DHApplyController@UploadImage');
            $api->post('/GetQrCode','DHApplyController@GetQrCode');
        });

        /*库存路由*/
        $api->group(['prefix'=>'inventory'], function ($api){
            $api->get('getcrowninventoryinfo', 'InventoryController@getCrownInventoryInfo');

            $api->get('getgoodsinventory', 'InventoryController@getGoodsInventory');
            $api->get('exportgoodsinventory', 'InventoryController@exportGoodsInventory');
            $api->post('importgoodsinventory', 'InventoryController@importGoodsInventory');
            $api->post('updategoodsinventory', 'InventoryController@updateGoodsInventory');
            $api->get('getgoodsinventorylog', 'InventoryController@getGoodsInventoryLog');
        });

    });
});
