<?php

namespace App\Http\Controllers;

use App\Models\Admin;
use App\Models\AgentOperationLog;
use App\Models\User;
use App\Models\UserCert;
use App\Models\Warea;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Carbon\Carbon;

class UserController extends Controller
{
    //获取代理列表信息
    public function getUserList(Request $request)
    {

        $input = $request->all();
        $page_size = $input['page_size'];
        $page_index = $input['page_index'];
        $num = ($page_index - 1) * $page_size;
        $search_name = $input['search_name'];
        $info_select = $input['info_select'];
        $recom_name = $request->has('recom_name') ? $input['recom_name'] : '';
        $agent_name = $request->has('agent_name') ? $input['agent_name'] : '';
        $commissar_id = $input['commissar'];
        $warea_id = $input['warea_id'];
        $where = [];
        if ($input['level'] == '4') {
            $user = User::onlyTrashed()->where($where);
        } elseif ($input['level'] == 'all') {
            $user = User::withTrashed()->where($where);
        } elseif ($input['level']==5){
            $user = User::withTrashed()->where($where)->where('freeze_status',1);
        }else {
            $where['level'] = $input['level'];
            $user = User::where($where);
        }

        if ($request->has('start_time')){
            Log::error('时间');
            if ($input['start_time']){
                $user->where('created_at','>=',$input['start_time']);
            }
        }
        if ($request->has('end_time')){
            if ($input['end_time']){
                $user->where('created_at','<=',$input['end_time']);
            }
        }
        if ($input['level']!=4){
            $user->whereIn('cert_status', [3, 6])->where('service_status','<>',2);
        }

//        if ($search_name) {
//            $user->where(function ($query) use ($search_name) {
//                $query->where('nickname', 'like', '%' . $search_name . '%')
//                    ->orWhere('mobile', $search_name)
//                    ->orWhere('cre_num', $search_name)
//                    ->orWhere('realname', 'like', '%' . $search_name . '%');
//            });
//        }
        if ($search_name) {
            if ($info_select==1){
                $user->where(function ($query) use ($search_name) {
                    $query->where('nickname', 'like', '%' . $search_name . '%')
                        ->orWhere('mobile', 'like','%'.$search_name.'%' )
                        ->orWhere('cre_num', $search_name)
                        ->orWhere('realname', 'like', '%' . $search_name . '%');
                });
            }elseif ($info_select==2){
                $recom_id = $this->getUserInfo($search_name);
                $user->whereIn('recom_id', $recom_id);
            }else{
                $agent_id = $this->getUserInfo($search_name);
                $user->whereIn('agent_id', $agent_id);
            }
        }

//        if ($agent_name) {
//            $agent_id = $this->getUserInfo($agent_name);
//            $user->whereIn('agent_id', $agent_id);
//
//        }
//        if ($recom_name) {
//            $recom_id = $this->getUserInfo($recom_name);
//            $user->whereIn('recom_id', $recom_id);
//
//        }
//<<<<<<< HEAD

        if ($warea_id && $commissar_id) {
            $user->where('warea_id', $warea_id);
        }
        if ($commissar_id && empty($warea_id)) {
            $warea_ids = Warea::where('admin_id', $commissar_id)->pluck('id');
            $user->whereIn('warea_id', $warea_ids);
        }
        $count = $user->where($where)->count();
        if ($count == 0) {
            $this->error('400001', '没有数据');
        }
        $list = $user->with(['recom:id,nickname,mobile', 'agent:id,nickname,mobile,level', 'warea:id,name,admin_name'])
            ->select('deleted_at','id', 'nickname','name', 'remark','realname', 'level', 'headimgurl', 'mobile', 'recom_id','remark_name','freeze_status','login_at','freeze_time', 'agent_id','service_status', 'warea_id','cre_num', 'status','province','city','country','address','in_group',
                DB::raw('if(cert_status=3,6,6) as cert_status'), DB::raw('if(deleted_at,1,0) as deleted'))
            ->orderBy('id', 'desc')->skip($num)->take($page_size)->get();

        $admin=Auth::user();
        $status=false;
        if($admin->role_id==22 || $admin->role_id==32){
            $status=true;
        }
        foreach ($list as $k=>$v){

            if (empty($v->remark)){
                $list[$k]['remark']='';
            }
            if ($v->deleted_at){
                $list[$k]['deletd_info']=AgentOperationLog::where('user_id',$v->id)
                    ->where('type',4)->orderByDesc('created_at')->first();
            }
            if (!empty($v->headimgurl)){
                $list[$k]['headimgurl']=mb_substr($v->headimgurl,0,-3).'0';
            }
            if ($v->level!=3 && $v->level!=0){
                if ($v->agent && $v->agent->level==3 || $v->agent->level==0){
                    $list[$k]->crown=$v->agent;
                }else{
                    $res=$this->get_crown($v->agent->id);
                    $list[$k]->crown=$res;
                }
            }else{
                $list[$k]->crown='';
            }
            if (!$status){
                if ($list[$k]->cre_num){
                    $list[$k]->cre_num=mb_substr($list[$k]->cre_num,0,2).'********'.mb_substr($list[$k]->cre_num,14);
                }
            }


//            $list[$k]['is_test']=1;
//            $test_user=TestUser::where('phone',$v->mobile)->first();
//            if(!empty($test_user) ){
//                $list[$k]['is_test']=0;
//            }
        }
        return $this->success_list($list, '获取数据成功', $count);
    }

    /**查找代理公司**/
    public function get_crown($id){
        $re=User::with(['agent:id,nickname,mobile,level'])->where('id',$id)->first();
        if (!$re){
            return '';
        }
        if ($re->agent && $re->agent->level!=3 && $re->agent->level!=0){
            $res=$this->get_crown($re->agent->id);
            return $res;
        }
        return $re->agent;
    }

    //代理详情
    public function getUserDetails(Request $request)
    {
        $input = $request->all();
        $user = User::withTrashed()->with(['recom:id,nickname,mobile', 'agent:id,nickname,mobile'
        ])->where('id', $input['id'])->first();
        if ($user) {
            if ($user->level == '3') {
                $childAgent = User::where('agent_id', $user->id)->select('id', 'nickname', 'level', 'mobile')->get()->toArray();
                $childAgentIds = array_column($childAgent, 'id');
                if ($childAgentIds) {
                    $childChildAgent = User::whereIn('agent_id', $childAgentIds)->select('id', 'nickname', 'level', 'mobile')->get()->toArray();
                    $user->child_agent = array_merge($childAgent, $childChildAgent);
                } else {
                    $user->child_agent = $childAgent;
                }
                $user->childAgentCount = count($user->child_agent);
            } elseif ($user->level == '2') {
                $user->child_agent = User::where('agent_id', $user->id)->select('id', 'nickname', 'level', 'mobile')->get()->toArray();
                $user->childAgentCount = count($user->child_agent);
                $user->change_info=AgentOperationLog::where('user_id',$user->id)->where('type',2)->first();
            } else {
                $user->child_agent = [];
                $user->childAgentCount = 0;
            }
            if ($user->warea_id) {
                $warea = Warea::where('id', $user->warea_id)->first();
                $user['warea']->warea_name = $warea->name;
                if ($warea->admin_id) {
                    $user['warea']->commissar = Admin::where('id', $warea->admin_id)->value('name');
                }
            }

            if (!empty($user->deleted_at)) {
                $user->delete = '1';//已删除
            } else {
                $user->delete = '0';//未删除
            }
            if ($user->cre_num){
                $user->cre_num=mb_substr($user->cre_num,0,2).'********'.mb_substr($user->cre_num,14);
            }

            $user->up_team=$this->getUpTeam($user->id);
//            event(new ChangeUserInfo($user));
            return $this->success($user);
        } else {
            return $this->error('400004', '代理信息不存在');
        }
    }

    //获取代理升级后团队信息
    public function getUpTeam($uid){
        $user=User::withTrashed()->where('id',$uid)->first();
        $arr=[];
        $num=0;
        if($user->level==2){
            $this->getAgentLevelInfoTwo($uid,$arr,$num);
        }elseif($user->level==1){
            $this->getAgentLevelInfoOne($uid,$arr,$num);
        }
        $data['num']=$num;
        $data['list']=$arr;
        return $data;
    }

    /**点击查看身份证号**/
    public function GetCreNum(Request $request){
        $id=$request->input('id');
        $cre_num=User::where('id',$id)->select('cre_num','mobile','nickname')->first();
        $data=['type'=>0,'time'=>Carbon::now()->toDateTimeString(),
            'created_at'=>Carbon::now()->toDateTimeString(),'updated_at'=>Carbon::now()->toDateTimeString(),
            'user_id'=>$id,
            'log'=>Auth::user()->name.'查看了该代理('.$cre_num->nickname.'手机号：'.$cre_num->mobile.')的身份证号码。'
        ];
        DB::table('look_user_log')->insert($data);
        return $this->success(['cre_num'=>$cre_num->cre_num]);
    }

    //顶级升皇冠
    public function getAgentLevelInfoTwo($uid,&$arr,&$num){
        $list=User::where('recom_id', $uid)->select('id','nickname','realname','mobile','level','recom_id')->get();//获取所有邀请人
        if(count($list)>0){
            foreach($list as $key=>$val){
                if($val->level=='2' || $val->level=='1'){
                    $num+=1;
//                    array_push($arr,$val);
                    $this->getAgentLevelInfoTwo($val->id,$arr,$num);
                }
            }
        }
    }
    //特级升顶级
    public function getAgentLevelInfoOne($uid,&$arr,&$num){
        $list=User::where('recom_id', $uid)->select('id','nickname','realname','mobile','level','recom_id')->get();//获取所有邀请人
        if(count($list)>0){
            foreach($list as $key=>$val){
                if($val->level=='1'){
                    $num+=1;
//                    array_push($arr,$val);
                    $this->getAgentLevelInfoOne($val->id,$arr,$num);
                }
            }
        }
    }

    /**获取现在和历史邀请人信息**/
    public function GetNowHistory(Request $request){
        $id=$request->input('id');
        $user=User::where('id',$id)->withTrashed()->first();
        $NowRom=User::where('id',$user->recom_id)->select('nickname','id','headimgurl','mobile','realname','level')->withTrashed()->first();

        $user_cert=UserCert::where('user_id',$id)->first();

        $data['now']=$NowRom;
        $data['history']=[];
        $arr=[];
        if ($user_cert){
            if ($user_cert->recom_id==$user->recom_id){

                $data['history']=[];
            }else{
                $recom_user=User::where('id',$user_cert->recom_id)->select('nickname','id','headimgurl','mobile','realname','level','deleted_at')->withTrashed()->first()->toArray();

                if ($recom_user){
                    if ($recom_user['deleted_at']){
                        $recomuser_cert=AgentOperationLog::where('user_id',$recom_user['id'])->where('type',4)->value('remark');
                        $t=['remark'=>$recomuser_cert];
                        $t=array_merge($recom_user,$t);
                        $arr[]=$t;
                    }
                }

                $user_cert=AgentOperationLog::where('user_id',$id)->where('type',3)->get();

                foreach ($user_cert as $k=>$v){
                    $num=stripos($v->log,'null');
                    if (!is_numeric($num)){
                        $log=mb_substr($v->log,13);
                        $num=stripos($log,',');
                        $ids=mb_substr($log,0,$num);
                        $usser=User::where('id',$ids)->select('nickname','id','headimgurl','mobile','realname','level','deleted_at')->withTrashed()->first()->toarray();
                        $t=['remark'=>$v->remark];
                        $t=array_merge($usser,$t);

                        $arr[]=$t;
                    }
                }
                $data['history']=$arr;
            }
        }
        return $this->success($data);
    }
}
