<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Role extends Model
{
//    use Notifiable;

    protected $fillable = ['name','permissions','desc','disable'];

    protected $hidden = [];
    // Rest omitted for brevity

    /**
     * Get the identifier that will be stored in the subject claim of the JWT.
     *
     * @return mixed
     */
    public function getJWTIdentifier()
    {
        return $this->getKey(); /*自己可以定义的生成token的参数,我用的是将主键加密*/
    }

    /**
     * Return a key value array, containing any custom claims to be added to the JWT.
     *
     * @return array
     */
    public function getJWTCustomClaims()
    {
        return [];
    }

    //定义表
    protected $table = "roles";

    //定义主键
    protected $primaryKey = "id";

    /**
     * 获得拥有此角色的管理员。
     */
    public function admin()
    {
        return $this->belongsTo('App\Admin','id','role_id');
    }
}
