<?php

namespace App\Models\Sharon;

use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Model;
use DateTimeInterface;
use Carbon\Carbon;
use App\Models\User as DWBSUser;

class Sharon extends Model{

    use SoftDeletes;
    protected $connection = 'mysql_s';
    protected $table='sharon';
    protected $guarded=[];
    protected function serializeDate(DateTimeInterface $date): string
    {
        return $date->format('Y-m-d H:i:s');
    }
    public static function setField()
    {
        return self::query()->select('id',
            'user_id',
            'start_at',
            'end_at',
            'state',
            'reason',
            'province',
            'city',
            'area',
            'address',
            'except_num',
            'actual_num',
            'sale_num',
            'agent_num'
        );
    }
    public function user()
    {
        return $this->hasOne(DWBSUser::class,'user_id')->withTrashed();
    }

    public function dwbsUser()
    {
        return $this->belongsTo(DWBSUser::class,'user_id');
    }

    public function img()
    {
        return $this->hasMany(Image::class,'sharon_id')->withTrashed();
    }

}
