<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Store extends Model
{
    use SoftDeletes;
    protected $table='store';
    protected $fillable = ['name','type','contents','status','address','man_id','province','city','area','warea_id','size','img'];
    public function agent()
    {
            return $this->belongsToMany('App\Models\User','store_user','store_id','user_id');
    }
    public function manager()
    {
        return $this->hasOne('App\Models\User','id','man_id');
    }
    public function user()
    {
        return $this->belongsTo('App\Models\User','man_id');
    }
    public function store_user()
    {
        return $this->hasMany('App\Models\StoreUser','store_id');
    }

    public function getCostAttribute($key)
    {
        $cost=$this->attributes['cost'];
        return preg_replace('/\.0+$/', '', $cost);
    }
    public function getAmountAttribute($key)
    {
        $amount=$this->attributes['amount'];
        return preg_replace('/\.0+$/', '', $amount);
    }
}
