<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Log;

class TraceTest extends Model
{
    protected $table='se_code';

    protected $fillable=['level','pid','sort','track_status','is_true','com_binding','user_id','security_code','code','child_num','select_num','is_lowest','model','act_id'];

    const MODEL_ONE = '1:6:36';
    const MODEL_TWO = '1:6:24';
    const MODEL_THREE = '1:10';
    const MODEL_FOUR = '1:12';


    public static $model = [
        self::MODEL_ONE => ['grade'=>3,'num'=>['num2'=>6,'num3'=>6]],
        self::MODEL_TWO => ['grade'=>3,'num'=>['num2'=>6,'num3'=>4]],
        self::MODEL_THREE => ['grade'=>2,'num'=>['num2'=>10]],
        self::MODEL_FOUR => ['grade'=>2,'num'=>['num2'=>12]],
    ];

    public function get_child(){
        return $this->hasMany(Trace::class,'pid');
    }
    public function get_childs(){
        return $this->hasMany(Trace::class,'pid','sort');
    }
    public function user(){
        return $this->belongsTo(User::class,'user_id');
    }

    public function get_goods(){
        return $this->belongsTo(TraceGoods::class,'good_select_id');
    }

    public function get_express(){
        return $this->hasMany(TraceExpress::class,'select_id');
    }

    public static function add_code($pid,$grade,$num,$i)
    {
        if($pid==0){
            $level=1;
            $code=self::code().'0000';
        }else{
            $ll=Trace::where('id',$pid)->value('level');
            $level=$ll+1;
            if($i<10){
                $i='0'.$i;
            }
            if($grade==2){
                $code=substr($pid,0,strlen($pid)-4).$i.'00';
            }
            if($grade==3){
                $code=substr($pid,0,strlen($pid)-2).$i;
            }
        }
        if($level==$grade){
            $is_lowest=1;
            $child_num=0;
        }else{
            $n='num'.($level+1);
            $child_num=$num[$n];
            $is_lowest=0;
        }
        $code=self::code();
        $result=Trace::create([
            'level'=>$level,
            'pid'=>$pid,
            'sort'=>$code,
            'track_status'=>0,
            'is_true'=>0,
            'com_binding'=>1,
            'user_id'=>null,
            'security_code'=>mt_rand(10000000,99999999),
            'code'=>$code,
            'child_num'=>$child_num,
            'select_num'=>0,
            'is_lowest'=>$is_lowest,
        ]);
        return $result->id;
    }

    public static function code(){
        $strs="ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
        $string=substr(str_shuffle($strs),mt_rand(0,strlen($strs)-9),8);
        $code=date("ymdHis",time()).$string;
        return $code;
    }


    protected $appends = ['max_code','sec_code'];

    const URL_CODE = 'http://fangw.jiuweiyun.cn/api/auth/';
    public function getMaxCodeAttribute($key)
    {
        $code=$this->attributes['code'];
        $max_code=self::URL_CODE.substr($code,'0',strlen($code)-4).'0000';
        return $max_code;
    }

    public function getSecCodeAttribute($key)
    {
        $code=$this->attributes['code'];
        $model=$this->attributes['model'];
        $count=substr_count($model,':');
        if($count>=2){
            $sec_code=self::URL_CODE.substr($code,'0',strlen($code)-2).'00';
        }else{
            $sec_code='';
        }

        return $sec_code;
    }

    public function getCodeAttribute($key)
    {
        $code=$this->attributes['code'];
        $code=self::URL_CODE.$code;
        return $code;
    }

}
